; _______________________________________________________________________________________
;|                                                                                       |
;| ..:: Fresh IDE ::..  template project.                                                |
;|_______________________________________________________________________________________|
;
;  Description: FreshLib portable GUI application.
;
;  Target OS: Any, supported by FreshLib
;
;  Dependencies: FreshLib
;
;  Notes:
;_________________________________________________________________________________________

include "%lib%/freshlib.inc"

@BinaryType GUI, compact

include "%lib%/freshlib.asm"

; include your includes here.
include "MainForm.asm"

start:
        InitializeAll

        create  [pApplication], TApplication

        call    GUI.Init

        stdcall CreateFromTemplate, frmMainForm, 0

        set     [pApplication], TApplication:MainWindow, frmMain

        stdcall Run

        FinalizeAll
        stdcall TerminateAll, 0

