; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: TLabel object class
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Not finished.
;_________________________________________________________________________________________
module "TLabel library"



object TLabel, TCanvasWindow

; private fields
  ._textalign    dd ?

; parameters
  param .TextAlign, ._textalign, .SetTextAlign        ; text align flags.

; parameter methods
  method .SetTextAlign, .value
  method .SetCaption, .value

; other methods
  method .Create, .parent

  method .__RenderView

endobj



method TLabel.Create
begin
        push    eax

        inherited [.parent]

        mov     eax, [.self]
        mov     [eax+TLabel._textalign], dtfAlignLeft or dtfAlignMiddle or dtfCRLF or dtfWordWrap

        pop     eax
        return
endp



method TLabel.SetTextAlign
begin
        push    eax ecx

        mov     eax, [.self]
        mov     ecx, [.value]

        xchg    ecx, [eax+TLabel._textalign]
        cmp     ecx, [eax+TLabel._textalign]
        je      .finish

        xor     ecx, ecx
        and     [eax+TLabel._canvas_valid], ecx
        exec    eax, TWindow:RectChanged2, ecx

.finish:
        pop     ecx eax
        return
endp



method TLabel.SetCaption       ;, .value
begin
        inherited [.value]

        push    eax
        mov     eax, [.self]
        and     [eax+TLabel._canvas_valid], 0
        pop     eax
        exec    [.self], TLabel:RectChanged2, 0
        return
endp



method TLabel.__RenderView
 .bounds TBounds
begin
        pushad

        mov     esi, [.self]
        mov     edi, [esi+TLabel._canvas]
        test    edi, edi
        jz      .finish

        xor     edx, edx
        mov     ecx, [esi+TLabel._width]
        mov     eax, [esi+TLabel._height]
        mov     [.bounds.x], edx
        mov     [.bounds.y], edx
        mov     [.bounds.width], ecx
        mov     [.bounds.height], eax

        lea     eax, [.bounds]
        stdcall [DrawBox], edi, eax, [GUI.clLabelBk], bxNone, [GUI.boxBorderWidth]

        get     eax, esi, TWindow:Caption
        test    eax, eax
        jz      .finish

        stdcall DrawTextBox, edi, eax, [.bounds.x], [.bounds.y], [.bounds.width], [.bounds.height], 2, [esi+TLabel._textalign], [GUI.DefaultFont], [GUI.clLabelTxt]
        stdcall StrDel, eax

.finish:
        popad
        return
endp



endmodule