; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: FontConfig import library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________



import_proto 'libfontconfig.so.1',                                                                              \
             FcInit,                   <VOID>,                          'FcInit',                               \
             FcFini,                   <VOID>,                          'FcFini',                               \
             FcInitLoadConfigAndFonts, <VOID>,                          'FcInitLoadConfigAndFonts',             \
             FcPatternCreate,          <VOID>,                          'FcPatternCreate',                      \
             FcObjectSetBuild,         <.first, ...>,                   'FcObjectSetBuild',                     \
             FcFontList,               <.config, .pPattern, .ObjSet>,   'FcFontList',                           \
             FcPatternGetString,       <.pPattern, .obj, .n, .pBuffer>, 'FcPatternGetString',                   \
             FcPatternGetInteger,      <.pPattern, .obj, .n, .pInt>,    'FcPatternGetInteger',                  \
             FcFontSetDestroy,         <.pFontSet>,                     'FcFontSetDestroy',                     \
             FcNameParse,              <.name>,                         'FcNameParse',                          \
             FcConfigSubstitute,       <.config, .pattern, .matchkind>, 'FcConfigSubstitute',                   \
             FcDefaultSubstitute,      <.pattern>,                      'FcDefaultSubstitute',                  \
             FcFontMatch,              <.config, .pattern, .pResult>,   'FcFontMatch',                          \
             FcPatternDestroy,         <.pattern>,                      'FcPatternDestroy',                     \
             FcPatternPrint,           <.pattern>,                      'FcPatternPrint'
