; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: MIT_SHM extension import library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto 'libXext.so.6',                                                                                            \
             XShmQueryExtension,        <.Disp>,                                     'XShmQueryExtension',              \
             XShmQueryVersion,          <.Disp, .piMajor, .piMinor, .pfPixmaps>,     'XShmQueryVersion',                \
             XShmPixmapFormat,          <.Disp>,                                     'XShmPixmapFormat',                \
             XShmAttach,                <.Disp, .pSegmentInfo>,                      'XShmAttach',                      \
             XShmDetach,                <.Disp, .pSegmentInfo>,                      'XShmDetach',                      \
             XShmCreateImage,           <.Disp, .Visual, .depth, .format,                                               \
                                         .pData, .pShmInfo, .width, .height>,        'XShmCreateImage',                 \
             XShmPutImage,              <.Disp, .Drawable, .context, .pImage,                                           \
                                         .SrcX, .SrcY, .DestX, .DestY,                                                  \
                                         .width, .height, .fSendEvent >,             'XShmPutImage',                    \
             XShmGetImage,              <.Disp, .Drawable, .pImage,                                                     \
                                         .X, .Y, .PlaneMask>,                        'XShmGetImage',                    \
             XShmCreatePixmap,          <.Disp, .Drawable, .pData, .pShmInfo,                                           \
                                         .width, .height, .depth>,                   'XShmCreatePixmap',                \
             XShmGetEventBase,           <.Disp>,                                     'XShmGetEventBase'