;   oleaut32.dll API calls (ASCII)
import_proto oleaut32,  \
    BSTR_UserFree, <.pLong, .pBstr>,  'BSTR_UserFree',  \
    BSTR_UserMarshal, <.pLong, .pChar, .pBstr>,  'BSTR_UserMarshal',  \
    BSTR_UserSize, <.pLong, .lLong, .pBstr>,  'BSTR_UserSize',  \
    BSTR_UserUnmarshal, <.pLong, .pChar, .pBstr>,  'BSTR_UserUnmarshal',  \
    BstrFromVector, <.psa, .pBstr>,  'BstrFromVector',  \
    ClearCustData, <.pCustData>,  'ClearCustData',  \
    CreateDispTypeInfo, <.pidata, .lcid, .pptinfo>,  'CreateDispTypeInfo',  \
    CreateErrorInfo_Aut, <.pperrinfo>,  'CreateErrorInfo',  \
    CreateStdDispatch, <.punkOuter, .pvThis, .ptinfo, .ppunkStdDisp>,  'CreateStdDispatch',  \
    CreateTypeLib, <.syskind, .szFile, .ppctlib>,  'CreateTypeLib',  \
    CreateTypeLib2, <.syskind, .szFile, .ppctlib>,  'CreateTypeLib2',  \
    DispCallFunc, <.pvInstance, .oVft, .cc, .vtReturn, .cActuals, .prgvt, .prgpvarg, .pvargResult>,  'DispCallFunc',  \
    DispGetIDsOfNames, <.ptinfo, .rgszNames, .cNames, .rgdispid>,  'DispGetIDsOfNames',  \
    DispGetParam, <.pdispparams, .position, .vtTarg, .pvarResult, .puArgErr>,  'DispGetParam',  \
    DispInvoke, <.this, .ptinfo, .dispidMember, .wFlags, .pparams, .pvarResult, .pexcepinfo, .puArgErr>,  'DispInvoke',  \
    DllCanUnloadNow, <VOID>,  'DllCanUnloadNow',  \
    DllGetClassObject, <.rclsid, .riid, .ppv>,  'DllGetClassObject',  \
    DllRegisterServer, <VOID>,  'DllRegisterServer',  \
    DllUnregisterServer, <VOID>,  'DllUnregisterServer',  \
    DosDateTimeToVariantTime, <.wDosDate, .wDosTime, .pvtime>,  'DosDateTimeToVariantTime',  \
    GetActiveObject, <.rclsid, .pvReserved, .ppunk>,  'GetActiveObject',  \
    GetAltMonthNames, <.lcid, .prgp>,  'GetAltMonthNames',  \
    GetErrorInfo_Aut, <.dwReserved, .pperrinfo>,  'GetErrorInfo',  \
    GetRecordInfoFromGuids, <.rGuidTypeLib, .uVerMajor, .uVerMinor, .lcid, .rGuidTypeInfo, .ppRecInfo>,  'GetRecordInfoFromGuids',  \
    GetRecordInfoFromTypeInfo, <.pTypeInfo, .ppRecInfo>,  'GetRecordInfoFromTypeInfo',  \
    GetVarConversionLocaleSetting, <NONE>,  'GetVarConversionLocaleSetting',  \
    LHashValOfNameSys, <.syskind, .lcid, .szName>,  'LHashValOfNameSys',  \
    LHashValOfNameSysA, <.syskind, .lcid, .szName>,  'LHashValOfNameSysA',  \
    LPSAFEARRAY_Marshal, <NONE>,  'LPSAFEARRAY_Marshal',  \
    LPSAFEARRAY_Size, <NONE>,  'LPSAFEARRAY_Size',  \
    LPSAFEARRAY_Unmarshal, <NONE>,  'LPSAFEARRAY_Unmarshal',  \
    LPSAFEARRAY_UserFree, <.pLong, .lpsafearray>,  'LPSAFEARRAY_UserFree',  \
    LPSAFEARRAY_UserMarshal, <.pLong, .pChar, .lpsafearray>,  'LPSAFEARRAY_UserMarshal',  \
    LPSAFEARRAY_UserSize, <.pLong, .lLong, .lpsafearray>,  'LPSAFEARRAY_UserSize',  \
    LPSAFEARRAY_UserUnmarshal, <.pLong, .pChar, .lpsafearray>,  'LPSAFEARRAY_UserUnmarshal',  \
    LoadRegTypeLib, <.rguid, .wVerMajor, .wVerMinor, .lcid, .pptlib>,  'LoadRegTypeLib',  \
    LoadTypeLib, <.TLpszModule, .TPpTypeLib>,  'LoadTypeLib',  \
    LoadTypeLibEx, <.szFile, .regkind, .pptlib>,  'LoadTypeLibEx',  \
    OACreateTypeLib2, <NONE>,  'OACreateTypeLib2',  \
    OaBuildVersion, <VOID>,  'OaBuildVersion',  \
    OleCreateFontIndirect, <.lpFontDesc, .riid, .lplpvObj>,  'OleCreateFontIndirect',  \
    OleCreatePictureIndirect, <.lpPictDesc, .riid, .fOwn, .lplpvObj>,  'OleCreatePictureIndirect',  \
    OleCreatePropertyFrame, <.hwndOwner, .x, .y, .lpszCaption, .cObjects, .ppUnk, .cPages, .pPageClsID, .lcid, .dwReserved, .pvReserved,  \
      >,  'OleCreatePropertyFrame',  \
    OleCreatePropertyFrameIndirect, <.lpParams>,  'OleCreatePropertyFrameIndirect',  \
    OleIconToCursor, <.hinstExe, .hIcon>,  'OleIconToCursor',  \
    OleLoadPicture, <.lpstream, .lSize, .fRunmode, .riid, .lplpvObj>,  'OleLoadPicture',  \
    OleLoadPictureEx, <.lpstream, .lSize, .fRunmode, .riid, .xSizeDesired, .ySizeDesired, .dwFlags, .lplpvObj>,  'OleLoadPictureEx',  \
    OleLoadPictureFile, <.varFileName, .lplpdispPicture>,  'OleLoadPictureFile',  \
    OleLoadPictureFileEx, <.varFileName, .xSizeDesired, .ySizeDesired, .dwFlags, .lplpdispPicture>,  'OleLoadPictureFileEx',  \
    OleLoadPicturePath, <.szURLorPath, .punkCaller, .dwReserved, .clrReserved, .riid, .ppvRet>,  'OleLoadPicturePath',  \
    OleSavePictureFile, <.lpdispPicture, .bstrFileName>,  'OleSavePictureFile',  \
    OleTranslateColor, <.lOleColor, .lHPalette, .lColorRef>,  'OleTranslateColor',  \
    QueryPathOfRegTypeLib, <.guid, .wMaj, .wMin, .lcid, .lpbstrPathName>,  'QueryPathOfRegTypeLib',  \
    RegisterActiveObject, <.punk, .rclsid, .dwFlags, .pdwRegister>,  'RegisterActiveObject',  \
    RegisterTypeLib, <.ptlib, .szFullPath, .szHelpDir>,  'RegisterTypeLib',  \
    RegisterTypeLibForUser, <NONE>,  'RegisterTypeLibForUser',  \
    RevokeActiveObject, <.dwRegister, .pvReserved>,  'RevokeActiveObject',  \
    SafeArrayAccessData, <.psa, .ppvData>,  'SafeArrayAccessData',  \
    SafeArrayAllocData, <.psa>,  'SafeArrayAllocData',  \
    SafeArrayAllocDescriptor, <.cDims, .ppsaOut>,  'SafeArrayAllocDescriptor',  \
    SafeArrayAllocDescriptorEx, <.vt, .cDims, .ppsaOut>,  'SafeArrayAllocDescriptorEx',  \
    SafeArrayCopy, <.psa, .ppsaOut>,  'SafeArrayCopy',  \
    SafeArrayCopyData, <.psaSource, .psaTarget>,  'SafeArrayCopyData',  \
    SafeArrayCreate, <.vt, .cDims, .rgsabound>,  'SafeArrayCreate',  \
    SafeArrayCreateEx, <.vt, .cDims, .rgsabound, .pvExtra>,  'SafeArrayCreateEx',  \
    SafeArrayCreateVector, <.vt, .lLbound, .cElements>,  'SafeArrayCreateVector',  \
    SafeArrayCreateVectorEx, <.vt, .lLbound, .cElements, .pvExtra>,  'SafeArrayCreateVectorEx',  \
    SafeArrayDestroy, <.psa>,  'SafeArrayDestroy',  \
    SafeArrayDestroyData, <.psa>,  'SafeArrayDestroyData',  \
    SafeArrayDestroyDescriptor, <.psa>,  'SafeArrayDestroyDescriptor',  \
    SafeArrayGetDim, <.psa>,  'SafeArrayGetDim',  \
    SafeArrayGetElement, <.psa, .rgIndices, .pv>,  'SafeArrayGetElement',  \
    SafeArrayGetElemsize, <.psa>,  'SafeArrayGetElemsize',  \
    SafeArrayGetIID, <.psa, .pguid>,  'SafeArrayGetIID',  \
    SafeArrayGetLBound, <.psa, .nDim, .plLbound>,  'SafeArrayGetLBound',  \
    SafeArrayGetRecordInfo, <.psa, .prinfo>,  'SafeArrayGetRecordInfo',  \
    SafeArrayGetUBound, <.psa, .nDim, .plUbound>,  'SafeArrayGetUBound',  \
    SafeArrayGetVartype, <.psa, .pvt>,  'SafeArrayGetVartype',  \
    SafeArrayLock, <.psa>,  'SafeArrayLock',  \
    SafeArrayPtrOfIndex, <.psa, .rgIndices, .ppvData>,  'SafeArrayPtrOfIndex',  \
    SafeArrayPutElement, <.psa, .rgIndices, .pv>,  'SafeArrayPutElement',  \
    SafeArrayRedim, <.psa, .psaboundNew>,  'SafeArrayRedim',  \
    SafeArraySetIID, <.psa, .guid>,  'SafeArraySetIID',  \
    SafeArraySetRecordInfo, <.psa, .prinfo>,  'SafeArraySetRecordInfo',  \
    SafeArrayUnaccessData, <.psa>,  'SafeArrayUnaccessData',  \
    SafeArrayUnlock, <.psa>,  'SafeArrayUnlock',  \
    SetErrorInfo_Aut, <.dwReserved, .perrinfo>,  'SetErrorInfo',  \
    SetOaNoCache, <NONE>,  'SetOaNoCache',  \
    SetVarConversionLocaleSetting, <NONE>,  'SetVarConversionLocaleSetting',  \
    SysAllocString, <.pOlechar>,  'SysAllocString',  \
    SysAllocStringByteLen, <.m_pBase, .FunctionCall>,  'SysAllocStringByteLen',  \
    SysAllocStringLen, <.pOlechar, .uint>,  'SysAllocStringLen',  \
    SysFreeString, <.bstr>,  'SysFreeString',  \
    SysReAllocString, <.pBstr, .pOlechar>,  'SysReAllocString',  \
    SysReAllocStringLen, <.pBstr, .pOlechar, .uint>,  'SysReAllocStringLen',  \
    SysStringByteLen, <.bstr>,  'SysStringByteLen',  \
    SysStringLen, <.bstr>,  'SysStringLen',  \
    SystemTimeToVariantTime, <.lpSystemTime, .pvtime>,  'SystemTimeToVariantTime',  \
    UnRegisterTypeLib, <.libID, .wVerMajor, .wVerMinor, .lcid, .syskind>,  'UnRegisterTypeLib',  \
    UnRegisterTypeLibForUser, <NONE>,  'UnRegisterTypeLibForUser',  \
    VARIANT_UserFree, <.pLong, .pVariant>,  'VARIANT_UserFree',  \
    VARIANT_UserMarshal, <.pLong, .pChar, .pVariant>,  'VARIANT_UserMarshal',  \
    VARIANT_UserSize, <.pLong, .lLong, .pVariant>,  'VARIANT_UserSize',  \
    VARIANT_UserUnmarshal, <.pLong, .pChar, .pVariant>,  'VARIANT_UserUnmarshal',  \
    VarAbs, <.pvarIn, .pvarResult>,  'VarAbs',  \
    VarAdd, <.pvarLeft, .pvarRight, .pvarResult>,  'VarAdd',  \
    VarAnd, <.pvarLeft, .pvarRight, .pvarResult>,  'VarAnd',  \
    VarBoolFromCy, <.cyIn, .pboolOut>,  'VarBoolFromCy',  \
    VarBoolFromDate, <.dateIn, .pboolOut>,  'VarBoolFromDate',  \
    VarBoolFromDec, <.pdecIn, .pboolOut>,  'VarBoolFromDec',  \
    VarBoolFromDisp, <.pdispIn, .lcid, .pboolOut>,  'VarBoolFromDisp',  \
    VarBoolFromI1, <.cIn, .pboolOut>,  'VarBoolFromI1',  \
    VarBoolFromI2, <.sIn, .pboolOut>,  'VarBoolFromI2',  \
    VarBoolFromI4, <.lIn, .pboolOut>,  'VarBoolFromI4',  \
    VarBoolFromI8, <NONE>,  'VarBoolFromI8',  \
    VarBoolFromR4, <.fltIn, .pboolOut>,  'VarBoolFromR4',  \
    VarBoolFromR8, <.dblIn, .pboolOut>,  'VarBoolFromR8',  \
    VarBoolFromStr, <.strIn, .lcid, .dwFlags, .pboolOut>,  'VarBoolFromStr',  \
    VarBoolFromUI1, <.bIn, .pboolOut>,  'VarBoolFromUI1',  \
    VarBoolFromUI2, <.uiIn, .pboolOut>,  'VarBoolFromUI2',  \
    VarBoolFromUI4, <.ulIn, .pboolOut>,  'VarBoolFromUI4',  \
    VarBoolFromUI8, <NONE>,  'VarBoolFromUI8',  \
    VarBstrCat, <.bstrLeft, .bstrRight, .pbstrResult>,  'VarBstrCat',  \
    VarBstrCmp, <.bstrLeft, .bstrRight, .lcid, .dwFlags>,  'VarBstrCmp',  \
    VarBstrFromBool, <.boolIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromBool',  \
    VarBstrFromCy, <.cyIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromCy',  \
    VarBstrFromDate, <.dateIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromDate',  \
    VarBstrFromDec, <.pdecIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromDec',  \
    VarBstrFromDisp, <.pdispIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromDisp',  \
    VarBstrFromI1, <.cIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromI1',  \
    VarBstrFromI2, <.iVal, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromI2',  \
    VarBstrFromI4, <.lIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromI4',  \
    VarBstrFromI8, <NONE>,  'VarBstrFromI8',  \
    VarBstrFromR4, <.fltIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromR4',  \
    VarBstrFromR8, <.dblIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromR8',  \
    VarBstrFromUI1, <.bVal, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromUI1',  \
    VarBstrFromUI2, <.uiIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromUI2',  \
    VarBstrFromUI4, <.ulIn, .lcid, .dwFlags, .pbstrOut>,  'VarBstrFromUI4',  \
    VarBstrFromUI8, <NONE>,  'VarBstrFromUI8',  \
    VarCat, <.pvarLeft, .pvarRight, .pvarResult>,  'VarCat',  \
    VarCmp, <.pvarLeft, .pvarRight, .lcid, .dwFlags>,  'VarCmp',  \
    VarCyAbs, <.cyIn, .pcyResult>,  'VarCyAbs',  \
    VarCyAdd, <.cyLeft, .cyRight, .pcyResult>,  'VarCyAdd',  \
    VarCyCmp, <.cyLeft, .cyRight>,  'VarCyCmp',  \
    VarCyCmpR8, <.cyLeft, .dblRight>,  'VarCyCmpR8',  \
    VarCyFix, <.cyIn, .pcyResult>,  'VarCyFix',  \
    VarCyFromBool, <.boolIn, .pcyOut>,  'VarCyFromBool',  \
    VarCyFromDate, <.dateIn, .pcyOut>,  'VarCyFromDate',  \
    VarCyFromDec, <.pdecIn, .pcyOut>,  'VarCyFromDec',  \
    VarCyFromDisp, <.pdispIn, .lcid, .pcyOut>,  'VarCyFromDisp',  \
    VarCyFromI1, <.cIn, .pcyOut>,  'VarCyFromI1',  \
    VarCyFromI2, <.sIn, .pcyOut>,  'VarCyFromI2',  \
    VarCyFromI4, <.lIn, .pcyOut>,  'VarCyFromI4',  \
    VarCyFromI8, <NONE>,  'VarCyFromI8',  \
    VarCyFromR4, <.fltIn, .pcyOut>,  'VarCyFromR4',  \
    VarCyFromR8, <.dblIn, .pcyOut>,  'VarCyFromR8',  \
    VarCyFromStr, <.strIn, .lcid, .dwFlags, .pcyOut>,  'VarCyFromStr',  \
    VarCyFromUI1, <.bIn, .pcyOut>,  'VarCyFromUI1',  \
    VarCyFromUI2, <.uiIn, .pcyOut>,  'VarCyFromUI2',  \
    VarCyFromUI4, <.ulIn, .pcyOut>,  'VarCyFromUI4',  \
    VarCyFromUI8, <NONE>,  'VarCyFromUI8',  \
    VarCyInt, <.cyIn, .pcyResult>,  'VarCyInt',  \
    VarCyMul, <.cyLeft, .cyRight, .pcyResult>,  'VarCyMul',  \
    VarCyMulI4, <.cyLeft, .lRight, .pcyResult>,  'VarCyMulI4',  \
    VarCyMulI8, <NONE>,  'VarCyMulI8',  \
    VarCyNeg, <.cyIn, .pcyResult>,  'VarCyNeg',  \
    VarCyRound, <.cyIn, .cDecimals, .pcyResult>,  'VarCyRound',  \
    VarCySub, <.cyLeft, .cyRight, .pcyResult>,  'VarCySub',  \
    VarDateFromBool, <.boolIn, .pdateOut>,  'VarDateFromBool',  \
    VarDateFromCy, <.cyIn, .pdateOut>,  'VarDateFromCy',  \
    VarDateFromDec, <.pdecIn, .pdateOut>,  'VarDateFromDec',  \
    VarDateFromDisp, <.pdispIn, .lcid, .pdateOut>,  'VarDateFromDisp',  \
    VarDateFromI1, <.cIn, .pdateOut>,  'VarDateFromI1',  \
    VarDateFromI2, <.sIn, .pdateOut>,  'VarDateFromI2',  \
    VarDateFromI4, <.lIn, .pdateOut>,  'VarDateFromI4',  \
    VarDateFromI8, <NONE>,  'VarDateFromI8',  \
    VarDateFromR4, <.fltIn, .pdateOut>,  'VarDateFromR4',  \
    VarDateFromR8, <.dblIn, .pdateOut>,  'VarDateFromR8',  \
    VarDateFromStr, <.strIn, .lcid, .dwFlags, .pdateOut>,  'VarDateFromStr',  \
    VarDateFromUI1, <.bIn, .pdateOut>,  'VarDateFromUI1',  \
    VarDateFromUI2, <.uiIn, .pdateOut>,  'VarDateFromUI2',  \
    VarDateFromUI4, <.ulIn, .pdateOut>,  'VarDateFromUI4',  \
    VarDateFromUI8, <NONE>,  'VarDateFromUI8',  \
    VarDateFromUdate, <.pudateIn, .dwFlags, .pdateOut>,  'VarDateFromUdate',  \
    VarDateFromUdateEx, <.pudateIn, .lcid, .dwFlags, .pdateOut>,  'VarDateFromUdateEx',  \
    VarDecAbs, <.pdecIn, .pdecResult>,  'VarDecAbs',  \
    VarDecAdd, <.pdecLeft, .pdecRight, .pdecResult>,  'VarDecAdd',  \
    VarDecCmp, <.pdecLeft, .pdecRight>,  'VarDecCmp',  \
    VarDecCmpR8, <.pdecLeft, .dblRight>,  'VarDecCmpR8',  \
    VarDecDiv, <.pdecLeft, .pdecRight, .pdecResult>,  'VarDecDiv',  \
    VarDecFix, <.pdecIn, .pdecResult>,  'VarDecFix',  \
    VarDecFromBool, <.boolIn, .pdecOut>,  'VarDecFromBool',  \
    VarDecFromCy, <.cyIn, .pdecOut>,  'VarDecFromCy',  \
    VarDecFromDate, <.dateIn, .pdecOut>,  'VarDecFromDate',  \
    VarDecFromDisp, <.pdispIn, .lcid, .pdecOut>,  'VarDecFromDisp',  \
    VarDecFromI1, <.cIn, .pdecOut>,  'VarDecFromI1',  \
    VarDecFromI2, <.uiIn, .pdecOut>,  'VarDecFromI2',  \
    VarDecFromI4, <.lIn, .pdecOut>,  'VarDecFromI4',  \
    VarDecFromI8, <NONE>,  'VarDecFromI8',  \
    VarDecFromR4, <.fltIn, .pdecOut>,  'VarDecFromR4',  \
    VarDecFromR8, <.dblIn, .pdecOut>,  'VarDecFromR8',  \
    VarDecFromStr, <.strIn, .lcid, .dwFlags, .pdecOut>,  'VarDecFromStr',  \
    VarDecFromUI1, <.bIn, .pdecOut>,  'VarDecFromUI1',  \
    VarDecFromUI2, <.uiIn, .pdecOut>,  'VarDecFromUI2',  \
    VarDecFromUI4, <.ulIn, .pdecOut>,  'VarDecFromUI4',  \
    VarDecFromUI8, <NONE>,  'VarDecFromUI8',  \
    VarDecInt, <.pdecIn, .pdecResult>,  'VarDecInt',  \
    VarDecMul, <.pdecLeft, .pdecRight, .pdecResult>,  'VarDecMul',  \
    VarDecNeg, <.pdecIn, .pdecResult>,  'VarDecNeg',  \
    VarDecRound, <.pdecIn, .cDecimals, .pdecResult>,  'VarDecRound',  \
    VarDecSub, <.pdecLeft, .pdecRight, .pdecResult>,  'VarDecSub',  \
    VarDiv, <.pvarLeft, .pvarRight, .pvarResult>,  'VarDiv',  \
    VarEqv, <.pvarLeft, .pvarRight, .pvarResult>,  'VarEqv',  \
    VarFix, <.pvarIn, .pvarResult>,  'VarFix',  \
    VarFormat, <.pvarIn, .pstrFormat, .iFirstDay, .iFirstWeek, .dwFlags, .pbstrOut>,  'VarFormat',  \
    VarFormatCurrency, <.pvarIn, .ByValumDig, .iIncLead, .iUseParens, .iGroup, .dwFlags, .pbstrOut>,  'VarFormatCurrency',  \
    VarFormatDateTime, <.pvarIn, .ByValamedFormat, .dwFlags, .pbstrOut>,  'VarFormatDateTime',  \
    VarFormatFromTokens, <.pvarIn, .pstrFormat, .pbTokCur, .dwFlags, .pbstrOut, .lcid>,  'VarFormatFromTokens',  \
    VarFormatNumber, <.pvarIn, .ByValumDig, .iIncLead, .iUseParens, .iGroup, .dwFlags, .pbstrOut>,  'VarFormatNumber',  \
    VarFormatPercent, <.pvarIn, .ByValumDig, .iIncLead, .iUseParens, .iGroup, .dwFlags, .pbstrOut>,  'VarFormatPercent',  \
    VarI1FromBool, <.boolIn, .pcOut>,  'VarI1FromBool',  \
    VarI1FromCy, <.cyIn, .pcOut>,  'VarI1FromCy',  \
    VarI1FromDate, <.dateIn, .pcOut>,  'VarI1FromDate',  \
    VarI1FromDec, <.pdecIn, .pcOut>,  'VarI1FromDec',  \
    VarI1FromDisp, <.pdispIn, .lcid, .pcOut>,  'VarI1FromDisp',  \
    VarI1FromI2, <.uiIn, .pcOut>,  'VarI1FromI2',  \
    VarI1FromI4, <.lIn, .pcOut>,  'VarI1FromI4',  \
    VarI1FromI8, <NONE>,  'VarI1FromI8',  \
    VarI1FromR4, <.fltIn, .pcOut>,  'VarI1FromR4',  \
    VarI1FromR8, <.dblIn, .pcOut>,  'VarI1FromR8',  \
    VarI1FromStr, <.strIn, .lcid, .dwFlags, .pcOut>,  'VarI1FromStr',  \
    VarI1FromUI1, <.bIn, .pcOut>,  'VarI1FromUI1',  \
    VarI1FromUI2, <.uiIn, .pcOut>,  'VarI1FromUI2',  \
    VarI1FromUI4, <.ulIn, .pcOut>,  'VarI1FromUI4',  \
    VarI1FromUI8, <NONE>,  'VarI1FromUI8',  \
    VarI2FromBool, <.boolIn, .psOut>,  'VarI2FromBool',  \
    VarI2FromCy, <.cyIn, .psOut>,  'VarI2FromCy',  \
    VarI2FromDate, <.dateIn, .psOut>,  'VarI2FromDate',  \
    VarI2FromDec, <.pdecIn, .psOut>,  'VarI2FromDec',  \
    VarI2FromDisp, <.pdispIn, .lcid, .psOut>,  'VarI2FromDisp',  \
    VarI2FromI1, <.cIn, .psOut>,  'VarI2FromI1',  \
    VarI2FromI4, <.lIn, .psOut>,  'VarI2FromI4',  \
    VarI2FromI8, <NONE>,  'VarI2FromI8',  \
    VarI2FromR4, <.fltIn, .psOut>,  'VarI2FromR4',  \
    VarI2FromR8, <.dblIn, .psOut>,  'VarI2FromR8',  \
    VarI2FromStr, <.strIn, .lcid, .dwFlags, .psOut>,  'VarI2FromStr',  \
    VarI2FromUI1, <.bIn, .psOut>,  'VarI2FromUI1',  \
    VarI2FromUI2, <.uiIn, .psOut>,  'VarI2FromUI2',  \
    VarI2FromUI4, <.ulIn, .psOut>,  'VarI2FromUI4',  \
    VarI2FromUI8, <NONE>,  'VarI2FromUI8',  \
    VarI4FromBool, <.boolIn, .plOut>,  'VarI4FromBool',  \
    VarI4FromCy, <.cyIn, .plOut>,  'VarI4FromCy',  \
    VarI4FromDate, <.dateIn, .plOut>,  'VarI4FromDate',  \
    VarI4FromDec, <.pdecIn, .plOut>,  'VarI4FromDec',  \
    VarI4FromDisp, <.pdispIn, .lcid, .plOut>,  'VarI4FromDisp',  \
    VarI4FromI1, <.cIn, .plOut>,  'VarI4FromI1',  \
    VarI4FromI2, <.sIn, .plOut>,  'VarI4FromI2',  \
    VarI4FromI8, <NONE>,  'VarI4FromI8',  \
    VarI4FromR4, <.fltIn, .plOut>,  'VarI4FromR4',  \
    VarI4FromR8, <.dblIn, .plOut>,  'VarI4FromR8',  \
    VarI4FromStr, <.strIn, .lcid, .dwFlags, .plOut>,  'VarI4FromStr',  \
    VarI4FromUI1, <.bIn, .plOut>,  'VarI4FromUI1',  \
    VarI4FromUI2, <.uiIn, .plOut>,  'VarI4FromUI2',  \
    VarI4FromUI4, <.ulIn, .plOut>,  'VarI4FromUI4',  \
    VarI4FromUI8, <NONE>,  'VarI4FromUI8',  \
    VarI8FromBool, <NONE>,  'VarI8FromBool',  \
    VarI8FromCy, <NONE>,  'VarI8FromCy',  \
    VarI8FromDate, <NONE>,  'VarI8FromDate',  \
    VarI8FromDec, <NONE>,  'VarI8FromDec',  \
    VarI8FromDisp, <NONE>,  'VarI8FromDisp',  \
    VarI8FromI1, <NONE>,  'VarI8FromI1',  \
    VarI8FromI2, <NONE>,  'VarI8FromI2',  \
    VarI8FromR4, <NONE>,  'VarI8FromR4',  \
    VarI8FromR8, <NONE>,  'VarI8FromR8',  \
    VarI8FromStr, <NONE>,  'VarI8FromStr',  \
    VarI8FromUI1, <NONE>,  'VarI8FromUI1',  \
    VarI8FromUI2, <NONE>,  'VarI8FromUI2',  \
    VarI8FromUI4, <NONE>,  'VarI8FromUI4',  \
    VarI8FromUI8, <NONE>,  'VarI8FromUI8',  \
    VarIdiv, <.pvarLeft, .pvarRight, .pvarResult>,  'VarIdiv',  \
    VarImp, <.pvarLeft, .pvarRight, .pvarResult>,  'VarImp',  \
    VarInt, <.pvarIn, .pvarResult>,  'VarInt',  \
    VarMod, <.pvarLeft, .pvarRight, .pvarResult>,  'VarMod',  \
    VarMonthName, <.iMonth, .fAbbrev, .dwFlags, .pbstrOut>,  'VarMonthName',  \
    VarMul, <.pvarLeft, .pvarRight, .pvarResult>,  'VarMul',  \
    VarNeg, <.pvarIn, .pvarResult>,  'VarNeg',  \
    VarNot, <.pvarIn, .pvarResult>,  'VarNot',  \
    VarNumFromParseNum, <.pnumprs, .rgbDig, .dwVtBits, .pvar>,  'VarNumFromParseNum',  \
    VarOr, <.pvarLeft, .pvarRight, .pvarResult>,  'VarOr',  \
    VarParseNumFromStr, <.strIn, .lcid, .dwFlags, .pnumprs, .rgbDig>,  'VarParseNumFromStr',  \
    VarPow, <.pvarLeft, .pvarRight, .pvarResult>,  'VarPow',  \
    VarR4CmpR8, <.fltLeft, .dblRight>,  'VarR4CmpR8',  \
    VarR4FromBool, <.boolIn, .pfltOut>,  'VarR4FromBool',  \
    VarR4FromCy, <.cyIn, .pfltOut>,  'VarR4FromCy',  \
    VarR4FromDate, <.dateIn, .pfltOut>,  'VarR4FromDate',  \
    VarR4FromDec, <.pdecIn, .pfltOut>,  'VarR4FromDec',  \
    VarR4FromDisp, <.pdispIn, .lcid, .pfltOut>,  'VarR4FromDisp',  \
    VarR4FromI1, <.cIn, .pfltOut>,  'VarR4FromI1',  \
    VarR4FromI2, <.sIn, .pfltOut>,  'VarR4FromI2',  \
    VarR4FromI4, <.lIn, .pfltOut>,  'VarR4FromI4',  \
    VarR4FromI8, <NONE>,  'VarR4FromI8',  \
    VarR4FromR8, <.dblIn, .pfltOut>,  'VarR4FromR8',  \
    VarR4FromStr, <.strIn, .lcid, .dwFlags, .pfltOut>,  'VarR4FromStr',  \
    VarR4FromUI1, <.bIn, .pfltOut>,  'VarR4FromUI1',  \
    VarR4FromUI2, <.uiIn, .pfltOut>,  'VarR4FromUI2',  \
    VarR4FromUI4, <.ulIn, .pfltOut>,  'VarR4FromUI4',  \
    VarR4FromUI8, <NONE>,  'VarR4FromUI8',  \
    VarR8FromBool, <.boolIn, .pdblOut>,  'VarR8FromBool',  \
    VarR8FromCy, <.cyIn, .pdblOut>,  'VarR8FromCy',  \
    VarR8FromDate, <.dateIn, .pdblOut>,  'VarR8FromDate',  \
    VarR8FromDec, <.pdecIn, .pdblOut>,  'VarR8FromDec',  \
    VarR8FromDisp, <.pdispIn, .lcid, .pdblOut>,  'VarR8FromDisp',  \
    VarR8FromI1, <.cIn, .pdblOut>,  'VarR8FromI1',  \
    VarR8FromI2, <.sIn, .pdblOut>,  'VarR8FromI2',  \
    VarR8FromI4, <.lIn, .pdblOut>,  'VarR8FromI4',  \
    VarR8FromI8, <NONE>,  'VarR8FromI8',  \
    VarR8FromR4, <.fltIn, .pdblOut>,  'VarR8FromR4',  \
    VarR8FromStr, <.strIn, .lcid, .dwFlags, .pdblOut>,  'VarR8FromStr',  \
    VarR8FromUI1, <.bIn, .pdblOut>,  'VarR8FromUI1',  \
    VarR8FromUI2, <.uiIn, .pdblOut>,  'VarR8FromUI2',  \
    VarR8FromUI4, <.ulIn, .pdblOut>,  'VarR8FromUI4',  \
    VarR8FromUI8, <NONE>,  'VarR8FromUI8',  \
    VarR8Pow, <.dblLeft, .dblRight, .pdblResult>,  'VarR8Pow',  \
    VarR8Round, <.dblIn, .cDecimals, .pdblResult>,  'VarR8Round',  \
    VarRound, <.pvarIn, .cDecimals, .pvarResult>,  'VarRound',  \
    VarSub, <.pvarLeft, .pvarRight, .pvarResult>,  'VarSub',  \
    VarTokenizeFormatString, <.pstrFormat, .rgbTok, .cbTok, .iFirstDay, .iFirstWeek, .lcid, .pcbActual>,  'VarTokenizeFormatString',  \
    VarUI1FromBool, <.boolIn, .pbOut>,  'VarUI1FromBool',  \
    VarUI1FromCy, <.cyIn, .pbOut>,  'VarUI1FromCy',  \
    VarUI1FromDate, <.dateIn, .pbOut>,  'VarUI1FromDate',  \
    VarUI1FromDec, <.pdecIn, .pbOut>,  'VarUI1FromDec',  \
    VarUI1FromDisp, <.pdispIn, .lcid, .pbOut>,  'VarUI1FromDisp',  \
    VarUI1FromI1, <.cIn, .pbOut>,  'VarUI1FromI1',  \
    VarUI1FromI2, <.sIn, .pbOut>,  'VarUI1FromI2',  \
    VarUI1FromI4, <.lIn, .pbOut>,  'VarUI1FromI4',  \
    VarUI1FromI8, <NONE>,  'VarUI1FromI8',  \
    VarUI1FromR4, <.fltIn, .pbOut>,  'VarUI1FromR4',  \
    VarUI1FromR8, <.dblIn, .pbOut>,  'VarUI1FromR8',  \
    VarUI1FromStr, <.strIn, .lcid, .dwFlags, .pbOut>,  'VarUI1FromStr',  \
    VarUI1FromUI2, <.uiIn, .pbOut>,  'VarUI1FromUI2',  \
    VarUI1FromUI4, <.ulIn, .pbOut>,  'VarUI1FromUI4',  \
    VarUI1FromUI8, <NONE>,  'VarUI1FromUI8',  \
    VarUI2FromBool, <.boolIn, .puiOut>,  'VarUI2FromBool',  \
    VarUI2FromCy, <.cyIn, .puiOut>,  'VarUI2FromCy',  \
    VarUI2FromDate, <.dateIn, .puiOut>,  'VarUI2FromDate',  \
    VarUI2FromDec, <.pdecIn, .puiOut>,  'VarUI2FromDec',  \
    VarUI2FromDisp, <.pdispIn, .lcid, .puiOut>,  'VarUI2FromDisp',  \
    VarUI2FromI1, <.cIn, .puiOut>,  'VarUI2FromI1',  \
    VarUI2FromI2, <.uiIn, .puiOut>,  'VarUI2FromI2',  \
    VarUI2FromI4, <.lIn, .puiOut>,  'VarUI2FromI4',  \
    VarUI2FromI8, <NONE>,  'VarUI2FromI8',  \
    VarUI2FromR4, <.fltIn, .puiOut>,  'VarUI2FromR4',  \
    VarUI2FromR8, <.dblIn, .puiOut>,  'VarUI2FromR8',  \
    VarUI2FromStr, <.strIn, .lcid, .dwFlags, .puiOut>,  'VarUI2FromStr',  \
    VarUI2FromUI1, <.bIn, .puiOut>,  'VarUI2FromUI1',  \
    VarUI2FromUI4, <.ulIn, .puiOut>,  'VarUI2FromUI4',  \
    VarUI2FromUI8, <NONE>,  'VarUI2FromUI8',  \
    VarUI4FromBool, <.boolIn, .pulOut>,  'VarUI4FromBool',  \
    VarUI4FromCy, <.cyIn, .pulOut>,  'VarUI4FromCy',  \
    VarUI4FromDate, <.dateIn, .pulOut>,  'VarUI4FromDate',  \
    VarUI4FromDec, <.pdecIn, .pulOut>,  'VarUI4FromDec',  \
    VarUI4FromDisp, <.pdispIn, .lcid, .pulOut>,  'VarUI4FromDisp',  \
    VarUI4FromI1, <.cIn, .pulOut>,  'VarUI4FromI1',  \
    VarUI4FromI2, <.uiIn, .pulOut>,  'VarUI4FromI2',  \
    VarUI4FromI4, <.lIn, .pulOut>,  'VarUI4FromI4',  \
    VarUI4FromI8, <NONE>,  'VarUI4FromI8',  \
    VarUI4FromR4, <.fltIn, .pulOut>,  'VarUI4FromR4',  \
    VarUI4FromR8, <.dblIn, .pulOut>,  'VarUI4FromR8',  \
    VarUI4FromStr, <.strIn, .lcid, .dwFlags, .pulOut>,  'VarUI4FromStr',  \
    VarUI4FromUI1, <.bIn, .pulOut>,  'VarUI4FromUI1',  \
    VarUI4FromUI2, <.uiIn, .pulOut>,  'VarUI4FromUI2',  \
    VarUI4FromUI8, <NONE>,  'VarUI4FromUI8',  \
    VarUI8FromBool, <NONE>,  'VarUI8FromBool',  \
    VarUI8FromCy, <NONE>,  'VarUI8FromCy',  \
    VarUI8FromDate, <NONE>,  'VarUI8FromDate',  \
    VarUI8FromDec, <NONE>,  'VarUI8FromDec',  \
    VarUI8FromDisp, <NONE>,  'VarUI8FromDisp',  \
    VarUI8FromI1, <NONE>,  'VarUI8FromI1',  \
    VarUI8FromI2, <NONE>,  'VarUI8FromI2',  \
    VarUI8FromI8, <NONE>,  'VarUI8FromI8',  \
    VarUI8FromR4, <NONE>,  'VarUI8FromR4',  \
    VarUI8FromR8, <NONE>,  'VarUI8FromR8',  \
    VarUI8FromStr, <NONE>,  'VarUI8FromStr',  \
    VarUI8FromUI1, <NONE>,  'VarUI8FromUI1',  \
    VarUI8FromUI2, <NONE>,  'VarUI8FromUI2',  \
    VarUI8FromUI4, <NONE>,  'VarUI8FromUI4',  \
    VarUdateFromDate, <.dateIn, .dwFlags, .pudateOut>,  'VarUdateFromDate',  \
    VarWeekdayName, <.iWeekday, .fAbbrev, .iFirstDay, .dwFlags, .pbstrOut>,  'VarWeekdayName',  \
    VarXor, <.pvarLeft, .pvarRight, .pvarResult>,  'VarXor',  \
    VariantChangeType, <.pvargDest, .pvarSrc, .wFlags, .vt>,  'VariantChangeType',  \
    VariantChangeTypeEx, <.pvargDest, .pvarSrc, .lcid, .wFlags, .vt>,  'VariantChangeTypeEx',  \
    VariantClear, <.pvarg>,  'VariantClear',  \
    VariantCopy, <.pvargDest, .pvargSrc>,  'VariantCopy',  \
    VariantCopyInd, <.pvarDest, .pvargSrc>,  'VariantCopyInd',  \
    VariantInit, <.pvarg>,  'VariantInit',  \
    VariantTimeToDosDateTime, <.vtime, .pwDosDate, .pwDosTime>,  'VariantTimeToDosDateTime',  \
    VariantTimeToSystemTime, <.vtime, .lpSystemTime>,  'VariantTimeToSystemTime',  \
    VectorFromBstr, <.bstr, .ppsa>,  'VectorFromBstr'
