; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Clipboard functions for inter-program communications.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: This file contains the OS independent part of the library and includes the
;         respective OS dependent file.
;_________________________________________________________________________________________

module "Clipboard library"


; Returns EAX handle to string with the content of the clipboard.

interface ClipboardRead



interface ClipboardWrite, .hstring



include '%TargetOS%/clipboard.asm'



endmodule