;<ff
Window frmIDEOptions, 3, 0, 'TForm', 'Aliases', $56000000, $10000, 0, 551, 273, 320, 275, IDEOptionsProc;
Window NONE, 0, 4, 'SysListView32', 'ListView', $5401800D, $200, 103, 0, 48, 312, 200, 0;
Window NONE, 0, 0, 'STATIC', 'A&liases:', $54000200, $0, 99, 8, 4, 64, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Add', $54010000, $0, 100, 96, 8, 64, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Remove', $54010000, $0, 101, 168, 8, 64, 19, 0;
Window NONE, 2, 0, 'BUTTON', '&Edit', $54010000, $0, 102, 240, 8, 64, 19, 0;
;ff>

iglobal
  SplitStart AliasLayout
    Split stVert or stJustGap, 8, 24, 0, 100
      Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 100
        Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 100
          Split stHoriz or stOriginBR or stJustGap, 8, 64, 0, 100
            Cell cellLabel
            Cell cellBtnAdd
          Cell cellBtnRemove
        Cell cellBtnEdit
      Cell cellListView
  SplitEnd


endg



proc IDEOptionsProc, .hwnd, .wmsg, .wparam, .lparam
  .lvi LVITEM
begin

.idButtonAdd  = 100
.idButtonDel  = 101
.idButtonEdit = 102
.idListView    = 103

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return

;--------------------------------
; Init columns of the listview
;--------------------------------
oncase FM_AFTERCREATE
locals
  .lvc LVCOLUMN
endl

iglobal
cTitleKey du 'Name', 0
cTitleVal du 'Value', 0
endg

        stdcall SetSplitGrid, [.hwnd], AliasLayout

        stdcall AttachToCellDlgItem, [.hwnd], 99, AliasLayout.cellLabel
        stdcall AttachToCellDlgItem, [.hwnd], 100, AliasLayout.cellBtnAdd
        stdcall AttachToCellDlgItem, [.hwnd], 101, AliasLayout.cellBtnRemove
        stdcall AttachToCellDlgItem, [.hwnd], 102, AliasLayout.cellBtnEdit
        stdcall AttachToCellDlgItem, [.hwnd], 103, AliasLayout.cellListView

;        invoke  SendMessageW, [.hwnd], SGM_REALIGN, 0, 0

        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT

        lea     ebx, [.lvc]

        mov     [.lvc.mask], LVCF_FMT or LVCF_TEXT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_RIGHT
        mov     [.lvc.pszText], cTitleKey
        mov     [.lvc.iSubItem], 0
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_INSERTCOLUMNW, 0, ebx

        mov     [.lvc.mask], LVCF_FMT or LVCF_TEXT or LVCF_SUBITEM
        mov     [.lvc.fmt], LVCFMT_LEFT
        mov     [.lvc.pszText], cTitleVal
        mov     [.lvc.iSubItem], 1
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_INSERTCOLUMNW, 1, ebx

        clc
        return


;----------------------------------------------------------
; Loads the path aliases ("environment variables") from
; the .ini file.
;-----------------------------------------------------------
oncase OM_LOADOPTIONS

        cmp     [.lparam], 0
        je      .readfromini

; read the aliases from array of type TEnvVarType (.lparam is pointer to pointer to TArray)

        mov     esi, [.lparam]
        mov     esi, [esi]
        test    esi, esi
        jz      .sizecols

        mov     ebx, [esi+TArray.count]
        lea     esi, [esi+TArray.array]

.insertloop:
        cmp     ebx, 0
        je      .sizecols

        stdcall utf8ToWideChar, [esi+TEnvVarType.pName]

        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_INSERTITEMW, 0, eax
        stdcall FreeMem, [.lvi.pszText]

        mov     [.lvi.iItem], eax

        stdcall utf8ToWideChar, [esi+TEnvVarType.pValue]
        mov     [.lvi.pszText], eax
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iSubItem], 1
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETITEMW, 0, eax
        stdcall FreeMem, [.lvi.pszText]

        add     esi, sizeof.TEnvVarType
        dec     ebx
        jmp     .insertloop


; read the aliases from ini file.
.readfromini:
        stdcall CfgGetSection, [hCfgFileName], _section_environment
        jc      .sizecols

        mov     edi, eax        ; the array with the key/value pairs.
        xor     ebx, ebx

.fillloop:
        cmp     ebx, [edi+TArray.count]
        jae     .endoflist

        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0

        stdcall utf8ToWideChar, [edi+8*ebx+TArray.array+TCfgRecord.key]
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_INSERTITEMW, 0, eax
        stdcall FreeMem, [.lvi.pszText]

        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], eax
        mov     [.lvi.iSubItem], 1

        stdcall utf8ToWideChar, [edi+8*ebx+TArray.array+TCfgRecord.value]
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETITEMW, 0, eax
        stdcall FreeMem, [.lvi.pszText]

        inc     ebx
        jmp     .fillloop

.endoflist:
        stdcall CfgFreeSection, edi

.sizecols:
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETCOLUMNWIDTH, 0, LVSCW_AUTOSIZE_USEHEADER
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETCOLUMNWIDTH, 1, LVSCW_AUTOSIZE_USEHEADER
        clc
        return

;--------------------------------------------------------------------
; Saves the paths to the .ini file on exit of the dialog with MR_OK
;--------------------------------------------------------------------
oncase OM_SAVEOPTIONS

locals
  .array  dd ?
  .buffer rw 1024
endl
        stdcall CreateArray, sizeof.TEnvVarType
        mov     [.array], eax

        xor     ebx, ebx

.getloop2:
        lea     eax, [.buffer]
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_GETITEMTEXTW, ebx, eax
        test    eax,eax
        jz      .endofitems2

        stdcall AddArrayItems, [.array], 1
        mov     [.array], edx
        mov     edi, eax

        lea     eax, [.buffer]
        stdcall WideCharToUtf8, eax
        mov     [edi+TEnvVarType.pName], eax

        lea     eax, [.buffer]
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_GETITEMTEXTW, ebx, eax

        lea     eax, [.buffer]
        stdcall WideCharToUtf8, eax
        mov     [edi+TEnvVarType.pValue], eax

        inc     ebx
        jmp     .getloop2

.endofitems2:
        cmp     [.lparam], 0
        je      .savetoini

; save to project poVarArray
        mov     esi, [.lparam]
        stdcall EmptyVarList, esi
        stdcall FreeMem, [esi]

        mov     eax, [.array]
        mov     [esi], eax

        clc
        return

.savetoini:
        stdcall CfgSaveSection, [hCfgFileName], _section_environment, [.array]
        stdcall CfgFreeSection, [.array]
        clc
        return


;-------------------------------------------------------------
; Well, executes the functions when
; one clicks on buttons "Add", "Edit", etc.
; Uses dialog box from the file "EditPath.frm"
;-------------------------------------------------------------
oncase WM_COMMAND

        movzx   esi, word [.wparam]

        cmp     esi, .idButtonAdd ; button near include path edit
        je      .addpath

        cmp     esi, .idButtonDel
        je      .delpath

        cmp     esi, .idButtonEdit
        jne     .ondefault

.editpath:
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        cmp     eax, -1
        jne     .getselected

        clc
        return

.getselected:
        mov     ebx, eax

        stdcall GetMem, 2048

        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        mov     [.lvi.cchTextMax], 1024
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_GETITEMTEXTW, ebx, eax
        stdcall WideCharToUtf8, [.lvi.pszText]
        mov     esi, eax

        mov     [.lvi.iSubItem], 1
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_GETITEMTEXTW, ebx, eax
        stdcall WideCharToUtf8, [.lvi.pszText]
        mov     edi, eax

        stdcall FreeMem, [.lvi.pszText]

        stdcall InputAliasName, [.hwnd], esi, edi
        cmp     eax, MR_OK
        jne     .exitdelstrings

        stdcall utf8ToWideChar, esi
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETITEMTEXTW, ebx, eax
        stdcall FreeMem, [.lvi.pszText]

        stdcall utf8ToWideChar, edi
        mov     [.lvi.iSubItem], 1
        mov     [.lvi.pszText], eax
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETITEMTEXTW, ebx, eax
        stdcall FreeMem, [.lvi.pszText]

.exitdelstrings:
        stdcall StrDel, esi
        stdcall StrDel, edi

        clc
        return

.addpath:
        stdcall StrNew
        mov     esi, eax
        stdcall StrNew
        mov     edi, eax

        stdcall InputAliasName, [.hwnd], esi, edi
        cmp     eax, MR_OK
        jne     .exitdelstrings

        stdcall utf8ToWideChar, esi
        mov     [.lvi.pszText], eax
        mov     [.lvi.mask], LVIF_TEXT
        mov     [.lvi.iItem], 10000
        mov     [.lvi.iSubItem], 0
        lea     eax, [.lvi]
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_INSERTITEMW, 0, eax
        stdcall FreeMem, [.lvi.pszText]

        lea     ecx, [.lvi]
        push    ecx
        push    eax

        stdcall utf8ToWideChar, edi
        mov     [.lvi.pszText], eax
        mov     [.lvi.iSubItem], 1
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_SETITEMTEXTW ; remaining from the stack
        stdcall FreeMem, [.lvi.pszText]
        jmp     .exitdelstrings


.delpath:
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED
        cmp     eax, -1
        jne     .delselected

        clc
        return

.delselected:
        invoke  SendDlgItemMessageW, [.hwnd], .idListView, LVM_DELETEITEM, eax, 0
        clc
        return


        enddispatch
endp