;<ff
Window frmHelpList, 3, 0, 'TForm', 'Help files list', $CC0000, $110001, 0, 858, 193, 320, 210, HelpFileWinProc;
Window NONE, 0, 3, 'LISTBOX', 'Listbox', $50810541, $200, 100, 0, 0, 312, 144, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010001, $0, 1, 90, 152, 64, 25, 0;
Window NONE, 2, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 158, 152, 64, 25, 0;
;ff>
idHelpList = 100

iglobal
  SplitStart HelpFilesLayout
    Split stVert or stJustGap or stOriginBR, 8, 33, 0, 100
      Cell cellHelpList
      Split stVert or stJustGap or stOriginBR, 0, 8, 0, 100
        Split stHoriz or stJustGap or stRelative, 8, 16384, 0, 32768
          Split stHoriz or stJustGap or stOriginBR, 0, 64, 0, 100
            Cell empty1
            Cell cellBtnOK
          Split stHoriz or stJustGap, 0, 64, 0, 100
            Cell cellBtnCancel
            Cell empty2
        Cell Empty3
  SplitEnd
endg




proc OnOpenHelpFile, .wparam, .lparam
begin
        pushad

        stdcall CreateForm, frmHelpList, [hMainForm]

        mov     esi, [ptrHelpFiles]
        test    esi, esi
        jz      .finish

        cmp    [esi+TArray.count], 0
        je     .finish

        xor     edi, edi
.loop:
        stdcall utf8ToWideChar, [esi+TArray.array+8*edi]
        push    eax
        invoke  SendDlgItemMessageW, ebx, idHelpList, LB_ADDSTRING, 0, eax      ; the first string is the title.
        stdcall FreeMem ; from the stack
        test    eax, eax
        js      .next

        invoke  SendDlgItemMessageW, ebx, idHelpList, LB_SETITEMDATA, eax, [esi+TArray.array+8*edi+4]   ; the second string is the filename.

.next:
        inc     edi
        cmp     edi, [esi+TArray.count]
        jne     .loop

        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .finish

        invoke  SendDlgItemMessageW, ebx, idHelpList, LB_GETCURSEL, 0, 0
        test    eax, eax
        js      .finish

        invoke  SendDlgItemMessageW, ebx, idHelpList, LB_GETITEMDATA, eax, 0

        stdcall SearchOneHelp, eax, 0, TRUE

.finish:
        invoke  DestroyWindow, ebx
        popad
        return
endp





proc HelpFileWinProc, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return

oncase FM_AFTERCREATE

        stdcall SetSplitGrid, [.hwnd], HelpFilesLayout

        stdcall AttachToCellDlgItem, [.hwnd], idHelpList, HelpFilesLayout.cellHelpList
        stdcall AttachToCellDlgItem, [.hwnd], IDOK, HelpFilesLayout.cellBtnOK
        stdcall AttachToCellDlgItem, [.hwnd], IDCANCEL, HelpFilesLayout.cellBtnCancel

        clc
        return

oncase WM_COMMAND
        cmp     word [.wparam+2], LBN_DBLCLK
        jne     .ondefault

        invoke  SetPropW, [.hwnd], [propModalResult], MR_OK
        xor     eax, eax
        clc
        return

        enddispatch
endp