;<ff
Window frmLabelProp, 3, 0, 'TForm', 'TForm window', $56000000, $10000, 0, 339, 137, 377, 318, frmLabelPropWinProc;
Window NONE, 0, 5, 'SysListView32', 'ListView', $5000800D, $200, 201, 0, 104, 369, 187, 0;
Window NONE, 3, 3, 'TForm', 'Form', $50000000, $0, 1, 0, 0, 369, 104, 0;
Window NONE, 0, 0, 'STATIC', 'Value:', $5000000B, $0, 0, 8, 4, 176, 16, 0;
Window NONE, 0, 0, 'EDIT', '', $50800884, $0, 10, 8, 20, 180, 17, 0;
Window NONE, 0, 0, 'STATIC', 'Size | Flags | type', $5000000B, $0, 0, 8, 44, 176, 16, 0;
Window NONE, 0, 0, 'EDIT', '', $50800884, $0, 11, 8, 60, 180, 17, 0;
Window NONE, 2, 0, 'STATIC', 'Reference list:', $50000000, $0, 0, 8, 88, 80, 16, 0;
;ff>


idLabelProp = 33
idXRefList = 201
idInfoPanel = 1


winmessage LPR_DISPLAY     ; wparam = hparent - handle of string with the name of the parent label; lparam = pointer to the TLabel;


uglobal
  hXRefFont dd ?
endg


iglobal
  cXRefFont du 'Courier New', 0

  SplitStart LblLayout
    Split stVert or stJustGap, 0, 104, 0, 1000
      Cell cellLabelInfo
      Cell cellXRef
  SplitEnd
endg


initialize InitLabelProperties
begin
        invoke  CreateFontW, -12, 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_MODERN, cXRefFont
        mov     [hXRefFont], eax
        return
endp


finalize FinalizeLabelProperties
begin
        invoke  DeleteObject, [hXRefFont]
        return
endp




proc frmLabelPropWinProc, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return



oncase WM_NOTIFY
locals
  .dblitem LVITEM
  .line    dd ?
endl

        cmp     [.wparam], idXRefList
        jne     .ondefault

        mov     esi, [.lparam]

        cmp     [esi+NMLISTVIEW.hdr.code], LVN_ITEMACTIVATE
        jne     .ondefault

        stdcall GetMem, 2048    ; buffer for the filename
        mov     edi, eax

        lea     ebx, [.dblitem]

        mov     [ebx+LVITEM.mask], LVIF_PARAM or LVIF_TEXT
        mov     eax, [esi+NMLISTVIEW.iItem]     ; list item double clicked
        mov     [ebx+LVITEM.iItem], eax
        mov     [ebx+LVITEM.iSubItem], 2        ; file name pointer
        mov     [ebx+LVITEM.pszText], edi
        mov     [ebx+LVITEM.cchTextMax], 1024

        invoke  SendMessageW, [esi+NMLISTVIEW.hdr.hwndFrom], LVM_GETITEMW, 0, ebx

        stdcall WideCharToUtf8, edi
        stdcall FreeMem, edi
        mov     edi, eax

        stdcall PosEditor, edi, [ebx+LVITEM.lParam]
        stdcall StrDel, edi

        clc
        return



oncase FM_AFTERCREATE

locals
  .col LVCOLUMN
endl

        stdcall SetSplitGrid, [.hwnd], LblLayout

        invoke  GetDlgItem, [.hwnd], idInfoPanel
        stdcall AttachToCell, eax, [.hwnd], LblLayout.cellLabelInfo

        invoke  GetDlgItem, [.hwnd], idXRefList
        mov     ebx, eax

        stdcall AttachToCell, ebx, [.hwnd], LblLayout.cellXRef

        lea     ecx, [.col]

        mov     [ecx+LVCOLUMN.mask], LVCF_FMT or LVCF_TEXT or LVCF_WIDTH or LVCF_SUBITEM
        mov     [ecx+LVCOLUMN.fmt], LVCFMT_LEFT
        mov     [ecx+LVCOLUMN.cx], 100
        mov     [ecx+LVCOLUMN.pszText], cColumnSymbolName
        mov     [ecx+LVCOLUMN.iSubItem], 0

        invoke  SendMessageW, ebx, LVM_INSERTCOLUMNW, 0, ecx

        lea     ecx, [.col]
        mov     [ecx+LVCOLUMN.mask], LVCF_FMT or LVCF_TEXT or LVCF_WIDTH or LVCF_SUBITEM
        mov     [ecx+LVCOLUMN.fmt], LVCFMT_LEFT
        mov     [ecx+LVCOLUMN.cx], 100
        mov     [ecx+LVCOLUMN.pszText], cColumnSource
        mov     [ecx+LVCOLUMN.iSubItem], 1

        invoke  SendMessageW, ebx, LVM_INSERTCOLUMNW, 1, ecx

        lea     ecx, [.col]
        mov     [ecx+LVCOLUMN.mask], LVCF_FMT or LVCF_TEXT or LVCF_WIDTH or LVCF_SUBITEM
        mov     [ecx+LVCOLUMN.fmt], LVCFMT_LEFT or LVCFMT_JUSTIFYMASK
        mov     [ecx+LVCOLUMN.cx], 100
        mov     [ecx+LVCOLUMN.pszText], cColumnFilename
        mov     [ecx+LVCOLUMN.iSubItem], 2

        invoke  SendMessageW, ebx, LVM_INSERTCOLUMNW, 2, ecx

        lea     ecx, [.col]
        mov     [ecx+LVCOLUMN.mask], LVCF_FMT or LVCF_TEXT or LVCF_WIDTH or LVCF_SUBITEM
        mov     [ecx+LVCOLUMN.fmt], LVCFMT_LEFT
        mov     [ecx+LVCOLUMN.cx], 100
        mov     [ecx+LVCOLUMN.pszText], cColumnLineNum
        mov     [ecx+LVCOLUMN.iSubItem], 3

        invoke  SendMessageW, ebx, LVM_INSERTCOLUMNW, 3, ecx
        invoke  SendMessageW, ebx, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_GRIDLINES or LVS_EX_FULLROWSELECT or LVS_EX_INFOTIP or LVS_EX_LABELTIP
        invoke  SendMessageW, ebx, WM_SETFONT, [hXRefFont], FALSE
        clc
        return

iglobal
  cColumnSymbolName du 'Symbol', 0
  cColumnSource     du 'Source line', 0
  cColumnFilename   du 'File', 0
  cColumnLineNum    du 'Line', 0
endg



oncase LPR_DISPLAY

; Pointer to TLabel structure of given label.
        mov     edi, [.lparam]
        test    edi, edi
        jz      .finish

        cmp     [.wparam], 0
        jne     .add_cross_reference

        invoke  GetDlgItem, [.hwnd], 1
        mov     ebx, eax

        stdcall NumToStr, [edi+TLabel.ValueLo], ntsUnsigned or ntsHex
        push    eax
        push    eax

        stdcall NumToStr, [edi+TLabel.ValueHi], ntsUnsigned or ntsHex
        stdcall StrCharInsert, eax, '$', 0
        stdcall StrCharCat, eax, ':'

        stdcall StrCat, eax     ; second from the stack
        stdcall StrDel ; from the stack

        stdcall SetDlgItemTextUtf8, ebx, 10, eax
        stdcall StrDel, eax

        movzx   eax, [edi+TLabel.DataSize]
        stdcall NumToStr, eax, ntsHex or ntsFixedWidth + 2
        mov     edx, eax
        stdcall StrCat, edx, cStrDelimiter
        movzx   eax, [edi+TLabel.flags]
        stdcall NumToStr, eax, ntsHex or ntsFixedWidth + 4
        push    eax
        stdcall StrCat, edx, eax
        stdcall StrDel ; from the stack
        stdcall StrCat, edx, cStrDelimiter
        movzx   eax, [edi+TLabel.type]
        stdcall NumToStr, eax, ntsHex or ntsFixedWidth + 2
        push    eax
        stdcall StrCat, edx, eax
        stdcall StrDel ; from the stack

        stdcall SetDlgItemTextUtf8, ebx, 11, edx
        stdcall StrDel, edx

.add_cross_reference:
; cross reference
        invoke  GetDlgItem, [.hwnd], idXRefList
        mov     ebx, eax

        cmp     [.wparam], 0
        jne     @f

        invoke  SendMessageW, ebx, LVM_DELETEALLITEMS, 0, 0

@@:
        mov     esi, [edi+TLabel.pXRefArray]
        test    esi, esi
        jz      .finish

        mov     ecx, [esi+TArray.count]
        test    ecx, ecx
        jz      .finish

        mov     [.count], ecx
        lea     esi, [esi+TArray.array]

locals
  .count dd ?
  .line_num dd ?
  .lvitem LVITEM
endl


.loop_xref:
        mov     ecx, [esi+TXRefInfo.ofsSource]
        add     ecx, [ptrPreprocessed]

.search_filename:
        mov     eax, [ecx+TIntLine.LineNumber]
        test    eax, eax
        jns     .direct

; the name of the macro
        mov    eax, [ecx+TIntLine.ofsGenerator]
        add    eax, [ptrPreprocessed]
        cmp    word [eax+1], '__'          ; internal macro definition... for example __UGlobalBlock or __IGlobalBlock
        je    .searchdown

        mov    ecx, [ecx+TIntLine.ofsSourceLine]
        add    ecx, [ptrPreprocessed]
        jmp   .search_filename

.searchdown:
        mov     ecx, [ecx+TIntLine.ofsMacroLine]
        add     ecx, [ptrPreprocessed]
        jmp     .search_filename

.direct:
        mov     [.line_num], eax

        mov     eax, [ecx+TIntLine.ofsGenerator]
        add     eax, [ptrPreprocessed]
        cmp     eax, [ptrPreprocessed]
        jne     .found

        stdcall StrPtr, [hStrFileName]

.found:
        push    eax     ; pointer to the filename

        mov     [.lvitem.mask], LVIF_PARAM or LVIF_TEXT
        mov     [.lvitem.iItem], $7fffffff
        mov     [.lvitem.iSubItem], 0

        mov     eax, [edi+TLabel.iName]
        add     eax, [ptrNames]
        stdcall utf8ToWideChar, eax

        mov     [.lvitem.pszText], eax

        mov     eax, [.line_num]
        mov     [.lvitem.lParam], eax

        lea     eax, [.lvitem]
        invoke  SendMessageW, ebx, LVM_INSERTITEMW, 0, eax
        stdcall FreeMem, [.lvitem.pszText]

        mov     [.lvitem.iItem], eax

; source line

        mov     eax, [esi+TXRefInfo.ofsSource]
        add     eax, [ptrPreprocessed]
        stdcall RestoreSourceLine, eax, '; '
        push    eax

        stdcall utf8ToWideChar, eax
        stdcall StrDel ; from the stack

        mov     [.lvitem.mask], LVIF_TEXT
        mov     [.lvitem.iSubItem], 1
        mov     [.lvitem.pszText], eax

        lea     eax, [.lvitem]
        invoke  SendMessageW, ebx, LVM_SETITEMTEXTW, [.lvitem.iItem], eax
        stdcall FreeMem, [.lvitem.pszText] ; from the stack

        mov     [.lvitem.mask], LVIF_TEXT
        mov     [.lvitem.iSubItem], 2


; the filename

        stdcall utf8ToWideChar ; from the stack
        mov     [.lvitem.pszText], eax

        lea     eax, [.lvitem]
        invoke  SendMessageW, ebx, LVM_SETITEMTEXTW, [.lvitem.iItem], eax

; the line number

        stdcall NumToStr, [.line_num], ntsUnsigned or ntsDec
        push    eax

        stdcall utf8ToWideChar, eax
        stdcall StrDel ; from the stack

        mov     [.lvitem.mask], LVIF_TEXT
        mov     [.lvitem.iSubItem], 3
        mov     [.lvitem.pszText], eax

        lea     eax, [.lvitem]
        invoke  SendMessageW, ebx, LVM_SETITEMTEXTW, [.lvitem.iItem], eax
        stdcall FreeMem, [.lvitem.pszText]

        add     esi, sizeof.TXRefInfo

        dec     [.count]
        jnz     .loop_xref

.end_insert:

; add the children labels to the cross reference list
        mov    edi, [edi+TLabel.Children]
        test   edi, edi
        jz     .finish

        mov     ebx, [edi+TArray.count]
        lea     edi, [edi+TArray.array]

.children_loop:
        dec     ebx
        js      .finish

        invoke  SendMessageW, [.hwnd], LPR_DISPLAY, 1, edi
        add     edi, sizeof.TLabel
        jmp     .children_loop


.finish:
        invoke  SendDlgItemMessageW, [.hwnd], idXRefList, LVM_GETITEMCOUNT, 0, 0
        OutputValue "Total item count: ", eax, 10, -1

        clc
        return

        enddispatch

endp



iglobal
  cSizeConst    text 'const',0
  cSizeByte     text 'byte', 0
  cSizeWord     text 'word', 0
  cSizeDword    text 'dword', 0
  cSizeQword    text 'qword', 0
  cStrDelimiter text ' | ', 0
endg




; there is another similar procedure "CreateLineString" in debug.asm file.
; TODO: these two procedures should be replaced by only one with common interface.

proc RestoreSourceLine, .ptrPreprocessedLine, .IgnoredChar
.char dd ?
begin
        push    esi edi ebx

        stdcall StrNew
        mov     edi, eax

        mov     esi, [.ptrPreprocessedLine]
        lea     esi, [esi+TIntLine.PreprocessedLine]

        mov     [.char], $20    ;202020

.getloop:
        xor     eax, eax
        lodsb
        test    al, al
        jz      .eol
        cmp     al, $3b
        je      .ignored        ; ignored token
        cmp     al, $1a         ; prefix of token
        je      .token
        cmp     al, $22         ; quoted text.
        je      .quoted

        stdcall StrCharCat, edi, eax

        cmp     al,','
        jne     .getloop

        mov     al,$20
        stdcall StrCharCat, edi, eax
        jmp     .getloop

.quoted:
        stdcall StrCharCat, edi, "'"

        lodsd                   ; length
        xor     edx, edx
        xchg    [esi+eax], edx
        stdcall StrCat, edi, esi
        xchg    [esi+eax], edx
        add     esi, eax

        stdcall StrCharCat, edi, "'"
        jmp     .getloop

.ignored:
        cmp     [.IgnoredChar], 0
        je      .token

        stdcall StrCharCat, edi, [.IgnoredChar]

.token:
        lodsb                   ; length
        movzx   eax, al
        xor     edx, edx
        xchg    [esi+eax], edx
        stdcall StrCat, edi, esi
        xchg    [esi+eax], edx
        add     esi, eax

        cmp     byte [esi], '['
        je      .tab
        cmp     byte [esi], $1a
        jne     .getloop

.tab:
        stdcall StrCharCat, edi, [.char]
        mov     byte [.char], $20
        jmp     .getloop

.eol:
        mov     eax, edi        ; string handle
        mov     edx, esi
        pop     ebx edi esi
        return
endp





