;<ff
Window frmProjectOptions, 3, 0, 'TForm', 'Project options', $24C0000, $10001, 0, 936, 71, 320, 400, winprocProjectOptions;
Window NONE, 0, 0, 'EDIT', '', $54010000, $0, 701, 8, 80, 304, 20, 0;
Window NONE, 0, 0, 'STATIC', '&Binary filename:', $54000000, $0, 800, 8, 24, 256, 16, 0;
Window NONE, 0, 0, 'EDIT', '', $54010180, $200, 703, 8, 40, 304, 21, 0;
Window NONE, 0, 0, 'BUTTON', '&Automatic name creation.', $54010003, $0, 702, 8, 8, 256, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $54010001, $0, 1, 96, 296, 64, 25, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $54010000, $0, 2, 168, 296, 64, 25, 0;
Window NONE, 2, 0, 'STATIC', 'Compiler &memory:', $54000200, $0, 801, 8, 64, 144, 16, 0;
;ff>

iglobal
  SplitStart POLayout
    Split stVert or stJustGap, 0, 21, 0, 100
      Cell cellCheckboxAuto
      Split stVert or stJustGap, 0, 21, 0, 100
        Cell cellLabelFilename
        Split stVert or stJustGap, 0, 21, 0, 100
          Cell cellEditFilename
          Split stVert or stJustGap, 0, 21, 0, 100
            Cell cellLabelMem
            Split stVert or stJustGap, 12, 21, 0, 100
              Cell cellComboMem
              Split stVert or stJustGap or stOriginBR, 8, 25, 0, 100
                Cell cellAliasForm
                Split stHoriz or stRelative or stJustGap, 8, 16384, 0, 32768
                  Split stHoriz or stOriginBR or stJustGap, 0, 64, 0, 100
                    Cell cellEmpty1
                    Cell cellBtnOK
                  Split stHoriz or stJustGap, 0, 64, 0, 100
                    Cell cellBtnCancel
                    Cell cellEmpty
  SplitEnd


endg



idComboMemory  = 701
idCheckboxAuto = 702
idEditFilename = 703

idAliasList = 1234


proc OnProjectOptions, .wparam, .lparam
begin
        push    ebx

        stdcall CreateForm, frmProjectOptions, [hMainForm]
        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .exit

; Get parameters back...

; Aliases:
        invoke  SendDlgItemMessageW, ebx, idAliasList, OM_SAVEOPTIONS, 0, poVarArray

        stdcall CreateParametersMenu

; Memory size
        stdcall GetDlgItemTextUtf8, ebx, idComboMemory
        push    eax

        stdcall StrToFasmNum, eax
        stdcall StrDel ; from the stack.

        stdcall SetCompilerMemorySize, eax

; Binary name
        stdcall GetDlgItemTextUtf8, ebx, idEditFilename
        stdcall StrDel, [poBinName]
        mov     [poBinName], eax

; Binary name auto flag
        invoke  SendDlgItemMessageW, ebx, idCheckboxAuto, BM_GETCHECK, 0, 0
        mov     [poBinNameAuto], eax

; mark the project as modified...
        invoke  SendMessageW, [hProjManager], _CEM_SETMODIFIED, TRUE, 0

.exit:
        invoke  DestroyWindow, ebx

        pop     ebx
        return
endp


;-----------------------------------------------------------------------
; Window procedure for the form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
proc winprocProjectOptions, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

        stc
        return



oncase SGM_REALIGN

        stdcall OnRealignWithPadding, [.hwnd], 8, 8, 8, 8

        clc
        return



oncase FM_AFTERCREATE

        stdcall SetSplitGrid, [.hwnd], POLayout

        stdcall AttachToCellDlgItem, [.hwnd], 702, POLayout.cellCheckboxAuto
        stdcall AttachToCellDlgItem, [.hwnd], 800, POLayout.cellLabelFilename
        stdcall AttachToCellDlgItem, [.hwnd], 703, POLayout.cellEditFilename
        stdcall AttachToCellDlgItem, [.hwnd], 801, POLayout.cellLabelMem
        stdcall AttachToCellDlgItem, [.hwnd], 701, POLayout.cellComboMem
        stdcall AttachToCellDlgItem, [.hwnd],   1, POLayout.cellBtnOK
        stdcall AttachToCellDlgItem, [.hwnd],   2, POLayout.cellBtnCancel


        stdcall CreateForm, frmIDEOptions, [.hwnd]
        invoke  SetWindowLongW, ebx, GWL_ID, idAliasList

        stdcall AttachToCell, ebx, [.hwnd], POLayout.cellAliasForm

        invoke  SendMessageW, ebx, OM_LOADOPTIONS, 0, poVarArray

        invoke  GetDlgItem, [.hwnd], idComboMemory
        mov     ebx, eax

        mov     esi, cMemorySizes

.sizesloop:
        invoke  SendMessageW, ebx, CB_ADDSTRING, 0, esi

.nxt_loop:
        lodsw
        test    ax, ax
        jnz     .nxt_loop

        cmp     word [esi], 0
        jne     .sizesloop

.endoflist:
        stdcall NumToStr, [poMemory], ntsUnsigned or ntsDec
        stdcall SetControlTextUtf8, ebx, eax
        stdcall StrDel, eax

; Set the binary filename.
        stdcall  SetDlgItemTextUtf8, [.hwnd], idEditFilename, [poBinName]

; Set the check in checkbox.
        mov     esi, [poBinNameAuto]
        invoke  SendDlgItemMessageW, [.hwnd], idCheckboxAuto, BM_SETCHECK, esi, 0

        test    esi, esi
        jz      .endcreate

        xor     esi, 1
        invoke  GetDlgItem, [.hwnd], idEditFilename
        invoke  EnableWindow, eax, esi

.endcreate:
        clc
        return


oncase WM_COMMAND
        cmp     word [.wparam], idCheckboxAuto
        je      .checkautoname

        stc
        return

.checkautoname:
        invoke  SendMessageW, [.lparam], BM_GETCHECK, 0, 0
        mov     ebx, eax

        xor     eax, 1
        push    eax
        invoke  GetDlgItem, [.hwnd], idEditFilename
        invoke  EnableWindow, eax

        clc
        return

        enddispatch
endp



iglobal
  cMemorySizes  du      '16384', 0
                du      '32768', 0
                du      '65536', 0
                du      '131072', 0
                du      '262144', 0
                du      '524288', 0
                du      '1048576', 0
                du      0
endg
