LIGHT_DARK_THRESHOLD = $80


iglobal
        NamedArray      GUI,                                    \
\
              imgUIIcons,     PNG, <'images/toolbar16_dark.png', 'images/toolbar16_light.png',        \
                                    'images/toolbar20_dark.png', 'images/toolbar20_light.png',        \
                                    'images/toolbar24_dark.png', 'images/toolbar24_light.png'>,       \
              imgMessages,    PNG, <'images/messages_dark.png', 'images/messages_light.png'>,         \
              imgNewDlg,      PNG, <'images/newdlg_dark.png', 'images/newdlg_light.png'>,             \
              imgApplets,     PNG, <'images/ideapplets_dark.png', 'images/ideapplets_light.png'>,     \
              imgCategories,  PNG, <'images/categories_dark.png', 'images/categories_light.png'>,     \
              imgFiles,       PNG, <'images/files_dark.png', 'images/files_light.png'>,               \
              imgEditorBmk,   PNG, <'images/editor_bmk_dark.png', 'images/editor_bmk_light.png'>,     \
              imgSelectTool,  PNG, 'images/arrow.png',                                                     \
              imgAbout,       PNG, 'images/about.png',                                                     \
\
              clSplitter,     HEX, <$00ccff, $bb7b3a>
endg


uglobal
  iTheme dd ?
endg



proc InitializeSkin
begin
        pushad

        invoke  GetSysColor, COLOR_BTNFACE

        movzx   ecx, al ; blue
        movzx   edx, ah ; green
        shr     eax, 16
        movzx   eax, al ; red

        lea     eax, [eax+2*ecx]
        add     eax, edx

        shr     eax, 2          ; gray middle level.

        cmp     eax, LIGHT_DARK_THRESHOLD
        seta    al
        movzx   eax, al

        mov     [iTheme], eax

        stdcall GUI.Init

        popad
        return
endp