;<ff
Window frmNewFromTemplate, 3, 0, 'TForm', 'New project from template...', $C0000, $10001, 0, 282, 106, 533, 384, frmTemplatesWinProc;
Window NONE, 0, 3, 'STATIC', ' &Directory for the project:', $50000200, $0, 500, 0, 0, 512, 24, 0;
Window NONE, 0, 3, 'TButtonEdit', '', $50000080, $200, 102, 0, 24, 512, 21, 0;
Window NONE, 0, 0, 'BUTTON', 'Cancel', $50010C00, $0, 2, 264, 320, 64, 24, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010C01, $0, 1, 184, 320, 64, 24, 0;
Window NONE, 0, 5, 'EDIT', '', $50200844, $200, 101, 256, 80, 256, 225, 0;
Window NONE, 0, 3, 'STATIC', ' Description:', $50000200, $0, 502, 264, 48, 256, 24, 0;
Window NONE, 0, 3, 'STATIC', ' &Template:', $50000200, $0, 501, 0, 48, 256, 24, 0;
Window NONE, 2, 5, 'LISTBOX', 'Listbox', $50010103, $200, 100, 0, 80, 256, 225, 0;
;ff>
idProjectsList = 100
idProjectDesc  = 101
idDirectory    = 102



uglobal
  hProjectsList dd ?
  hProjectDesc dd ?
endg

iglobal
  SplitStart NewAppLayout
    Split stVert or stJustGap, 0, 24, 0, 1000
      Cell cellLabel500
      Split stVert or stJustGap, 0, 21, 0, 1000
        Cell cellDirectory
        Split stVert or stOriginBR or stJustGap, 8, 24, 0, 100
          Split stHoriz or stJustGap or stRelative, 0, 16384, 0, 32768
            Split stVert or stJustGap, 0, 24, 0, 100
              Cell cellLabel501
              Cell cellProjectsList
            Split stVert or stJustGap, 0, 24, 0, 100
              Cell cellLabel502
              Cell cellProjDesc
          Split stHoriz or stJustGap or stRelative, 8, 16384, 0, 32768
            Split stHoriz or stJustGap or stOriginBR, 0, 64, 0, 100
              Cell empty1
              Cell cellBtnOK
            Split stHoriz or stJustGap, 0, 64, 0, 100
              Cell cellBtnCancel
              Cell empty2
  SplitEnd
endg


proc NewFromTemplate, .wparam, .lparam
.buffer rb 1024

.finddata FINDDATAW
.findhandle dd ?
.projectdir dd ?
begin
        push    esi

        stdcall CreateForm, frmNewFromTemplate, [hMainForm]

        stdcall GetCurrentDir
        stdcall SetDlgItemTextUtf8, ebx, idDirectory, eax
        stdcall StrDel, eax

        stdcall ShowModal, ebx, MSF_CENTER

        cmp     eax, MR_OK
        jne     .endtemplate

        stdcall GetDlgItemTextUtf8, ebx, idDirectory
        stdcall FixPathEnd, eax
        mov     [.projectdir], eax

; Close all open in the moment files.
;        stdcall OnCloseAll, 0, 0

; Open files of the directory like unsaved files.

; Get template directory

        stdcall ConvertAliasString, cTemplatesDir
        mov     esi, eax

        invoke  SendMessageW, [hProjectsList], LB_GETCURSEL, 0, 0
        stdcall GetListboxTextUtf8, [hProjectsList], eax

        stdcall StrCat, esi, eax
        stdcall StrCharCat, esi, '\'
        stdcall StrDel, eax

        lea     edi, [.finddata]

        stdcall StrDup, esi
        push    eax
        stdcall StrCat, eax, txt '*.*'

        stdcall utf8ToWideChar, eax
        stdcall StrDel ; from the stack
        push    eax

        invoke  FindFirstFileW, eax, edi
        stdcall FreeMem ; from the stack

        cmp     eax, INVALID_HANDLE_VALUE
        je      .endtemplate

        mov     [.findhandle], eax

.allloop:
        test    [edi+FINDDATAW.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jnz     .nextfile

        stdcall StrDup, [.projectdir]
        mov     edx, eax                        ; the new name in EDX

        lea     ecx, [edi+FINDDATAW.cFileName]
        stdcall WideCharToUtf8, ecx

        stdcall StrCat, edx, eax
        stdcall StrDel, eax

        stdcall StrDup, esi
        mov     ecx, eax

        lea     eax, [edi+FINDDATAW.cFileName]
        stdcall WideCharToUtf8, eax

        stdcall StrCat, ecx, eax   ; template name in ECX

        push    edx ecx

        stdcall OpenFileByName, edx, ecx, TRUE

        stdcall StrDel ; from the stack
        stdcall StrDel ; from the stack

        test    eax, eax
        jz      .nextfile

        mov     edx, eax
        mov     [edx+TOpenFile.fNeverSaved], TRUE

.nextfile:
        invoke  FindNextFileW, [.findhandle], edi
        test    eax, eax
        jnz     .allloop

.endtemplate:
        invoke  DestroyWindow, ebx
        stdcall StrDel, [.projectdir]

        pop     esi
        return
endp


iglobal
  cProjSelectPath du "Select directory where to create project.", 0
endg


proc frmTemplatesWinProc, .hwnd, .wmsg, .wparam, .lparam
.str rb 1024
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return

oncase BEM_BUTTONCLICK

        stdcall GetDlgItemTextUtf8, [.hwnd], idDirectory
        push    eax
        stdcall SelectPathDialog, [.hwnd], cProjSelectPath, eax
        stdcall StrDel ; from the stack
        test    eax, eax
        jz      .quit

        stdcall SetDlgItemTextUtf8, [.hwnd], idDirectory, eax
        stdcall StrDel, eax

.quit:
        clc
        return


oncase FM_ONIDLE

        invoke  SendMessageW, [hProjectsList], LB_GETCURSEL, 0, 0

        inc     eax
        push    eax

        invoke  GetDlgItem, [.hwnd], IDOK
        invoke  EnableWindow, eax ; flag from the stack.

        clc
        return

oncase SGM_REALIGN
        stdcall OnRealignWithPadding, [.hwnd], 8, 8, 8, 8
        clc
        return

oncase FM_AFTERCREATE

        stdcall SetSplitGrid, [.hwnd], NewAppLayout

        stdcall AttachToCellDlgItem, [.hwnd], idProjectsList, NewAppLayout.cellProjectsList
        stdcall AttachToCellDlgItem, [.hwnd], idProjectDesc, NewAppLayout.cellProjDesc
        stdcall AttachToCellDlgItem, [.hwnd], idDirectory, NewAppLayout.cellDirectory

        stdcall AttachToCellDlgItem, [.hwnd], 500, NewAppLayout.cellLabel500
        stdcall AttachToCellDlgItem, [.hwnd], 501, NewAppLayout.cellLabel501
        stdcall AttachToCellDlgItem, [.hwnd], 502, NewAppLayout.cellLabel502

        stdcall AttachToCellDlgItem, [.hwnd], IDOK, NewAppLayout.cellBtnOK
        stdcall AttachToCellDlgItem, [.hwnd], IDCANCEL, NewAppLayout.cellBtnCancel

cTemplatesDir text '%Fresh%\IDE\templates\'

locals
  .finddata FINDDATAW
endl

        invoke  GetDlgItem, [.hwnd], idProjectsList
        mov     [hProjectsList], eax

        invoke  GetDlgItem, [.hwnd], idProjectDesc
        mov     [hProjectDesc], eax

        stdcall ConvertAliasString, cTemplatesDir
        stdcall StrCat, eax, txt '*.*'
        push    eax

        stdcall utf8ToWideChar, eax
        stdcall StrDel ; from the stack
        mov     ebx, eax

        lea     edi, [.finddata]
        invoke  FindFirstFileW, ebx, edi
        stdcall FreeMem, ebx

        cmp     eax, INVALID_HANDLE_VALUE
        je      .endoffill

        mov     esi, eax

.loop:
        test    [edi+FINDDATAW.dwFileAttributes], FILE_ATTRIBUTE_DIRECTORY
        jz      .nextfile

        cmp     word [edi+FINDDATAW.cFileName], '.'
        je      .nextfile

        lea     eax, [edi+FINDDATAW.cFileName]
        invoke  SendMessageW, [hProjectsList], LB_ADDSTRING, 0, eax

.nextfile:
        invoke  FindNextFileW, esi, edi
        test    eax, eax
        jnz     .loop

        invoke  FindClose, esi

.endoffill:
        clc
        return


oncase WM_COMMAND

        cmp     word [.wparam+2], LBN_SELCHANGE
        jne     .ondefault

        invoke  SendMessageW, [.lparam], LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        je      .endcommand

        stdcall GetListboxTextUtf8, [.lparam], eax
        push    eax eax

        stdcall ConvertAliasString, cTemplatesDir
        mov     ebx, eax

        stdcall StrCat, ebx ; from the stack
        stdcall StrDel ; from the stack
        stdcall StrCat, ebx, "\readme.txt"

        stdcall LoadBinaryFile, ebx
        jc      .endcommand

        mov     edi, eax
        stdcall SetControlTextUtf8, [hProjectDesc], eax
        stdcall FreeMem, eax
        stdcall StrDel, ebx

.endcommand:
        clc
        return

        enddispatch
endp




proc frmPanelsWinProc, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return

oncase WM_COMMAND

        invoke  GetParent, [.hwnd]
        invoke  SendMessageW, eax, [.wmsg], [.wparam], [.lparam]

        clc
        return

        enddispatch
endp