#!/bin/bash

function test {
    "$@"
    status=$?
    if [ $status -ne 0 ]; then
        echo "error with $1"
    fi
    return $status
}

test xdg-icon-resource install --context mimetypes --size 16 ./x-asmsrc_light16.png text-x-asmsrc
test xdg-icon-resource install --context mimetypes --size 32 ./x-asmsrc_light32.png text-x-asmsrc

test xdg-icon-resource install --context mimetypes --size 16 ./x-freshform_light16.png text-x-freshform
test xdg-icon-resource install --context mimetypes --size 32 ./x-freshform_light32.png text-x-freshform

test xdg-icon-resource install --context mimetypes --size 16 ./x-freshproject_light16.png application-x-freshproject
test xdg-icon-resource install --context mimetypes --size 32 ./x-freshproject_light32.png application-x-freshproject

test xdg-mime install x-asmsrc.xml
test xdg-mime install x-freshform.xml
test xdg-mime install x-freshproject.xml