include '%lib%/freshlib.inc'

@BinaryType GUI

uses gdi32, comctl32

LIB_MODE equ old

include '%lib%/freshlib.asm'
include "%lib%/graphics/rectangles.asm"
include "%lib%/gui/themes/win_gui.asm"
include "%lib%/gui/themes.asm"

include '%finc%/libs/msgutils.inc'
include '%finc%/libs/templates.inc'
include '%finc%/libs/gui.inc'
include '%finc%/libs/TForm.inc'

include '%finc%/libs/msgutils.asm'
include '%finc%/libs/templates.asm'
include '%finc%/libs/TForm.asm'
include '%finc%/libs/gui.asm'
include '%finc%/libs/SplitGrid2.asm'

include "MainForm.frm"

uglobal
  hInstance dd ?
  hHeap     dd ?
  hMainForm dd ?
  iTheme    dd ?
endg


cString text 'test'


start:
        mov     eax, cString

        invoke  GetModuleHandleA,0
        mov     [hInstance],eax
        invoke  GetProcessHeap
        mov     [hHeap], eax

        call    GUI.Init
        InitializeAll

        stdcall CreateForm, frmMain, NULL
        xor     eax, eax
        test    ebx, ebx
        jz      .terminate

        mov     [hMainForm], ebx

.run:
        call    ProcessMessages
        jc      .terminate

        invoke  WaitMessage
        jmp     .run

.terminate:
        push    eax
        FinalizeAll
        invoke  ExitProcess ; exit code from the stack.

