; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: This file contains procedures and data, that form the appearance of the
;               TAsmEdit components.
;
;  Target OS: Any
;
;  Dependencies:
;_________________________________________________________________________________________
module "AsmEdit theme data and code library"


iglobal
        NamedArray      ASM,                                            \
\
\ ; Widgets border colors and width
                clBackground,     HEX, <$ff000080, $ff000090>,          \
                clSimpleText,     HEX, $ffffffff,                       \
                clProtectedText,  HEX, $ffa0a000,                       \
                clSelection,      HEX, $80ffffff,                       \
                clLeftMargin,     HEX, $ffc0c0c0,                       \
                clLeftMarginEdge, HEX, $ffffffff,                       \
                clLeftMarginText, HEX, $ff000000,                       \
                clLeftMarginTree, HEX, $ffff0000,                       \
                clBookmarkBack,   HEX, $ffffd000,                       \
\
                clWrapColumn,     HEX, $ff0000ff,                       \
\
                Options,          NUM, eoLeftMargin or eoLineNumbers,   \
                WrapPos,          NUM, 70,                              \
                MouseWheel,       NUM, 3,                               \
\
                iconBreakpoints,  PNG, <'%lib%/FreshEdit/themes/images/breakpoint_inactive.png', '%lib%/FreshEdit/themes/images/breakpoint.png'>,     \
                iconDebugInfo,    PNG, '%lib%/FreshEdit/themes/images/debug_icon.png',                                         \
                iconFoldings,     PNG, <'%lib%/FreshEdit/themes/images/unfold.png', '%lib%/FreshEdit/themes/images/fold.png'>,                        \
\
                lrIconBreakpoints,NUM, 3,                                                               \
\
\ ; Default mono font
\
                Font,             FONT, "Fixedsys Excelsior 3.01": 16 : fwNormal : ffMonospaced,      \
                NumFont,          FONT, "Liberation Mono": 12 : fwLight : 0
endg






endmodule
