; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: This file contains procedures and data, that form the appearance of the
;               TAsmEdit components.
;
;  Target OS: Any
;
;  Dependencies:
;_________________________________________________________________________________________
module "AsmEdit theme data and code library"


iglobal
        NamedArray      ASM,                                            \
\
\ ; Widgets border colors and width
                clBackground,     HEX, <$ffffffff, $ffe8e8e8>,          \
                clSimpleText,     HEX, $ff000000,                       \
                clProtectedText,  HEX, $ffa0a000,                       \
                clSelection,      HEX, $800000ff,                       \
                clLeftMargin,     HEX, $ffd0d0d8,                       \
                clLeftMarginEdge, HEX, $ff606060,                       \
                clLeftMarginText, HEX, $ff000000,                       \
                clLeftMarginTree, HEX, $ff9000ff,                       \
                clBookmarkBack,   HEX, $ffffd000,                       \
\
                clWrapColumn,     HEX, $ffc0c0ff,                       \
\
                Options,          NUM, eoLeftMargin or eoLineNumbers,   \
                WrapPos,          NUM, 70,                              \
                MouseWheel,       NUM, 3,                               \
\
                iconBreakpoints,  PNG, <'images/breakpoint_inactive.png', 'images/breakpoint.png'>,     \
                iconDebugInfo,    PNG, 'images/debug_icon.png',                                         \
                iconFoldings,     PNG, <'images/unfold.png', 'images/fold.png'>,                        \
\
\ ; Default mono font
\
                Font,             FONT, "Fixedsys Excelsior 3.01": 16 : fwNormal : ffMonospaced,      \
                NumFont,          FONT, "Liberation Mono": 12 : fwLight : 0
endg






endmodule
