; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Some equates for HTML control COM interfaces.
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


DOCHOSTUIFLAG_DIALOG = $00000001
DOCHOSTUIFLAG_DISABLE_HELP_MENU = $00000002
DOCHOSTUIFLAG_NO3DBORDER = $00000004
DOCHOSTUIFLAG_SCROLL_NO = $00000008
DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE = $00000010
DOCHOSTUIFLAG_OPENNEWWIN = $00000020
DOCHOSTUIFLAG_DISABLE_OFFSCREEN = $00000040
DOCHOSTUIFLAG_FLAT_SCROLLBAR = $00000080
DOCHOSTUIFLAG_DIV_BLOCKDEFAULT = $00000100
DOCHOSTUIFLAG_ACTIVATE_CLIENTHIT_ONLY = $00000200
DOCHOSTUIFLAG_OVERRIDEBEHAVIORFACTORY = $00000400
DOCHOSTUIFLAG_CODEPAGELINKEDFONTS = $00000800
DOCHOSTUIFLAG_URL_ENCODING_DISABLE_UTF8 = $00001000
DOCHOSTUIFLAG_URL_ENCODING_ENABLE_UTF8 = $00002000
DOCHOSTUIFLAG_ENABLE_FORMS_AUTOCOMPLETE = $00004000
DOCHOSTUIFLAG_ENABLE_INPLACE_NAVIGATION = $00010000
DOCHOSTUIFLAG_IME_ENABLE_RECONVERSION = $00020000
DOCHOSTUIFLAG_THEME = $00040000
DOCHOSTUIFLAG_NOTHEME = $00080000
DOCHOSTUIFLAG_NOPICS = $00100000
DOCHOSTUIFLAG_NO3DOUTERBORDER = $00200000
DOCHOSTUIFLAG_DISABLE_EDIT_NS_FIXUP = $00400000
DOCHOSTUIFLAG_LOCAL_MACHINE_ACCESS_CHECK = $00800000
DOCHOSTUIFLAG_DISABLE_UNTRUSTEDPROTOCOL = $01000000
DOCHOSTUIFLAG_HOST_NAVIGATES = $02000000
DOCHOSTUIFLAG_ENABLE_REDIRECT_NOTIFICATION = $04000000
DOCHOSTUIFLAG_USE_WINDOWLESS_SELECTCONTROL = $08000000
DOCHOSTUIFLAG_USE_WINDOWED_SELECTCONTROL = $10000000
DOCHOSTUIFLAG_ENABLE_ACTIVEX_INACTIVATE_MODE = $20000000
DOCHOSTUIFLAG_DPI_AWARE = $40000000

DOCHOSTUIDBLCLK_DEFAULT = 0
DOCHOSTUIDBLCLK_SHOWPROPERTIES = 1
DOCHOSTUIDBLCLK_SHOWCODE = 2




struct DOCHOSTUIINFO
  .cbSize dd ?
  .dwFlags  dd ?
  .dwDoubleClick dd ?
  .pchHostCss  dd ?
  .pchHostNS   dd ?
ends
