; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: This file contains procedures and data, that form the appearance of the
;               TAsmEdit components.
;
;  Target OS: Any
;
;  Dependencies:
;_________________________________________________________________________________________

;ciText         = 0
;ciComment      = 1
;ciString       = 2
;ciNumber       = 3
;ciSymbol       = 4
;ciRegister     = 5
;ciInstruction  = 6
;ciDerective    = 7
;ciPreprocessor = 8
;ciMacro        = 9

iglobal
        NamedArray      ASM,                                            \
\
\ ; Widgets border colors and width
                clBackground,     HEX, <$ffffffff, $fff0f0f0, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff, $ffffffff>, \
                clText,           HEX, <$ff000000, $ff8E908C, $ff718C00, $ffDE935F, $ff4080a0, $fff5871f, $ffc82829, $ff4271ae, $ff895Fa8, $ff000000, $ff000000, $ff000000, $ff000000, $ff000000, $ff000000, $ff000000, $ff000000>, \
                clProtectedText,  HEX, $ffa0a000,                       \
                clSelection,      HEX, $602980b9,                       \
\
                clLeftMargin,     HEX, $ff404040,                       \
                clLeftMarginEdge, HEX, $ffffffff,                       \
                clLeftMarginText, HEX, $ffffffff,                       \
                clLeftMarginTree, HEX, $ffff0000,                       \
                xspcLMPadding,    NUM, 4,                               \
\
                clBookmarkBack,   HEX, $ffffd000,                       \
\
                clWrapColumn,     HEX, $800000ff,                       \
\
                MouseWheel,       NUM, 3,                               \
\
                iconBreakpoints,  PNG, <'%lib%/FreshEdit/themes/images/breakpoint_inactive.png', '%lib%/FreshEdit/themes/images/breakpoint.png'>,       \
                iconDebugInfo,    PNG, '%lib%/FreshEdit/themes/images/debug_icon.png',                                                                  \
                iconFoldings,     PNG, <'%lib%/FreshEdit/themes/images/unfold.png', '%lib%/FreshEdit/themes/images/fold.png'>,                          \
\
                xspcIconBrkPnts,  NUM, 3,                                                                                                               \
\
\ ; Default mono font
\
                Font,             FONT, "Liberation Mono": 16 : fwNormal : ffMonospaced,      \ ;
                NumFont,          FONT, "Liberation Mono": 13 : fwLight : 0

        DispSize "ASM theme data", $ - ASM

endg

