; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: MIT_SHM extension import library.
;
;  Target OS: Linux
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________


import_proto 'libfreetype.so.6',                                                                                            \
             FT_Init_FreeType,   <.pLibrary>,                                'FT_Init_FreeType',                            \
             FT_New_Face,        <.library, .filename, .idxFace, .pFace>,    'FT_New_Face',                                 \
             FT_Set_Char_Size,   <.pFace, .width, .height, .hRes, .vRes>,    'FT_Set_Char_Size',                            \
             FT_Set_Pixel_Sizes, <.pFace, .pxWidth, .pxHeight>,              'FT_Set_Pixel_Sizes',                          \
             FT_Request_Size,    <.pFace, .pReq>,                            'FT_Request_Size',                             \
             FT_Get_Char_Index,  <.pFace, .char>,                            'FT_Get_Char_Index',                           \
             FT_Load_Glyph,      <.pFace, .idxGlyph, .flags>,                'FT_Load_Glyph',                               \
             FT_Render_Glyph,    <.pSlot, .RenderMode>,                      'FT_Render_Glyph',                             \
             FT_Done_Face,       <.pFace>,                                   'FT_Done_Face',                                \
             FT_Glyph_To_Bitmap, <.pGlyph, .render_mode, .pOrigin, .destroy>, 'FT_Glyph_To_Bitmap',                         \
             FT_Get_Kerning,     <.face, .left_glyph, .right_glyph, .kern_mode, .pKerning>, 'FT_Get_Kerning',               \
             FT_Get_Advance,     <.face, .gindex, .load_flags, .pAdvance>,   'FT_Get_Advance',                              \
             FTC_Manager_New,    <.library, .max_faces, .max_sizes,                                                         \
                                  .max_bytes, .requester, .req_data, .pManager>, 'FTC_Manager_New',                         \
             FTC_Manager_LookupFace, <.manager, .face_id, .pFace>,           'FTC_Manager_LookupFace',                      \
             FTC_Manager_LookupSize, <.manager, .scaler, .pSize>,            'FTC_Manager_LookupSize',                      \
             FTC_Manager_RemoveFaceID, <.manager, .face_id>,                 'FTC_Manager_RemoveFaceID',                    \
             FTC_ImageCache_New, <.manager, .pImageCache>,                   'FTC_ImageCache_New',                          \
             FTC_ImageCache_Lookup, <.cache, .type, .glyph_index,                                                           \
                                     .pGlyph, .pNode>,                       'FTC_ImageCache_Lookup',                       \
             FTC_ImageCache_LookupScaler, <.cache, .scaler, .load_flags,                                                    \
                                           .gindex, .pGlyph, .pNode>,        'FTC_ImageCache_LookupScaler',                 \
             FTC_CMapCache_New,  <.manager, .pCMapCache>,                    'FTC_CMapCache_New',                           \
             FTC_CMapCache_Lookup, <.cache, .face_id, .cmap_index, .char_code>, 'FTC_CMapCache_Lookup'




