;<ff
Window frmEditorColors, 3, 0, 'TForm', 'Editor options', $46000000, $10000, 0, 817, 214, 474, 426, CustomWinProc;
Window NONE, 0, 0, 'BUTTON', '&Color', $54010000, $0, 104, 312, 184, 40, 24, 0;
Window NONE, 0, 0, 'TForm', '', $54000000, $200, 109, 200, 184, 104, 24, 0;
Window NONE, 0, 0, 'ASMEDIT', '', $54010167, $200, 200, 4, 24, 188, 360, 0;
Window NONE, 0, 0, 'LISTBOX', '', $54310141, $200, 106, 200, 32, 152, 144, 0;
Window NONE, 0, 0, 'STATIC', '&Font:', $54000202, $0, 300, 4, 2, 24, 19, 0;
Window NONE, 0, 0, 'STATIC', 'Editor options:', $54000200, $0, 302, 208, 212, 160, 19, 0;
Window NONE, 0, 0, 'TButtonEdit', '', $56010880, $200, 111, 32, 4, 161, 19, 0;
Window NONE, 0, 0, 'BUTTON', 'Auto &brackets', $5401C003, $0, 416, 208, 232, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Auto &Indents', $5401C003, $0, 401, 208, 252, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Smart &tabulations', $5401C003, $0, 402, 208, 272, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', '&Secure selection', $5401C003, $0, 408, 208, 292, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', '&Optimal fill on saving', $5401C003, $0, 404, 208, 312, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', '&Console caret', $5401C003, $0, 432, 208, 332, 160, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Tab indents selection', $5401C003, $0, 464, 208, 352, 168, 16, 0;
Window NONE, 0, 0, 'STATIC', '&Syntax colors:', $54000200, $0, 301, 208, 4, 160, 19, 0;
Window NONE, 0, 0, 'BUTTON', '&Load', $54010000, $0, 102, 370, 48, 40, 21, 0;
Window NONE, 2, 0, 'BUTTON', '&Save', $54010000, $0, 103, 414, 48, 40, 21, 0;
;ff>

struct TEditorSettings
  .hFontName    dd  ?
  .FontSize     dd  ?
  .FontCharset  dd  ?
  .AsmEditStyle dd  ?
  .ptrTheme     dd  ?

  .FontWeight   dd  ?
  .FontItalic   dd  ?
ends


iglobal

  cThemesFilter:
        du 'Theme files (*.theme)', 0, '*.theme', 0
        du 'All files (*.*)', 0, '*.*',0
        du 0

  cThemeSaveTitle du "Save editor theme to file", 0
  cThemeLoadTitle du "Load editor theme from file", 0

  align 4

  property propTempSettings, 'TempSettings'


  cPreviewSource file 'PreviewSource.inc'
                 db   0

  cSynListboxColors:
          IndexedStrings                                          \
            aeTheme.text_color,      'Default text',              \
            aeTheme.text_background, 'Default background',        \
            aeTheme.sel_text,        'Selected text',             \
            aeTheme.sel_background,  'Selected background',       \
            aeTheme.focus_color,     'Focused line text',         \
            aeTheme.focus_background,'Focused line background',   \
            aeTheme.margin_background,'Left margin background',   \
            aeTheme.margin_border,    'Left margin border',       \
            aeTheme.rdonly_color,     'Read-only text color',     \
            aeTheme.rdonly_background,'Read-only background',     \
            aeTheme.syntax_colors+4*(clDirective-1),   'Assembler directive',     \
            aeTheme.syntax_colors+4*(clPreprocessor-1), 'Preprocessor directive', \
            aeTheme.syntax_colors+4*(clInstruction-1), 'Instruction',   \
            aeTheme.syntax_colors+4*(clRegister-1),    'Register',      \
            aeTheme.syntax_colors+4*(clSymbol-1),      'Symbol',        \
            aeTheme.syntax_colors+4*(clNumber-1),      'Number',        \
            aeTheme.syntax_colors+4*(clString-1),      'String',        \
            aeTheme.syntax_colors+4*(clComment-1),     'Comment'

  cFontCharsets:
          IndexedStrings                          \
            ANSI_CHARSET          , 'Western',    \
            DEFAULT_CHARSET       , 'Default',    \
            SYMBOL_CHARSET        , 'Symbol',     \
            SHIFTJIS_CHARSET      , 'Shiftjis',   \
            HANGEUL_CHARSET       , 'Hangeul',    \
            GB2312_CHARSET        , 'GB2312',     \
            CHINESEBIG5_CHARSET   , 'Chinese Big5',\
            OEM_CHARSET           , 'OEM',        \
            JOHAB_CHARSET         , 'Johab',      \
            HEBREW_CHARSET        , 'Hebrew',     \
            ARABIC_CHARSET        , 'Arabic',     \
            GREEK_CHARSET         , 'Greek',      \
            TURKISH_CHARSET       , 'Turkish',    \
            VIETNAMESE_CHARSET    , 'Vietnamese', \
            THAI_CHARSET          , 'Thai',       \
            EASTEUROPE_CHARSET    , 'Central European', \
            RUSSIAN_CHARSET       , 'Cyrillic',         \
            MAC_CHARSET           , 'Mac',              \
            BALTIC_CHARSET        , 'Baltic'

  SplitStart ColorsGrid
    Split stVert or stJustGap, 8, 25, 0, 100
      Split stHoriz or stJustGap, 8, 64, 0, 100
        Cell cellBtnLoad
        Split stHoriz or stJustGap, 8, 64, 0, 100
          Cell cellBtnSave
          Cell cellEmpty
      Split stHoriz or stOriginBR or stJustGap, 8, 180, 0, 1000
        Split stVert or stJustGap, 8, 21, 0, 32
          Split stHoriz or stJustGap, 8, 40, 0, 100
            Cell cellLabelFont
            Cell cellEditFont
          Cell cellSampleEdit
        Split stVert or stJustGap, 8, 17, 0, 32
          Cell cellLabelSyntax
          Split stVert or stOriginBR or stJustGap, 2, 16, 0, 100
            Split stVert or stOriginBR or stJustGap, 2, 16, 0, 100
              Split stVert or stOriginBR or stJustGap, 2, 16, 0, 100
                Split stVert or stOriginBR or stJustGap, 2, 16, 0, 100
                  Split stVert or stOriginBR or stJustGap, 2, 16, 0, 100
                    Split stVert or stOriginBR or stJustGap, 2, 16, 0, 100
                      Split stVert or stOriginBR or stJustGap, 8, 16, 0, 100
                        Split stVert or stOriginBR or stJustGap, 8, 17, 0, 100
                          Split stVert or stOriginBR or stJustGap, 8, 32, 0, 64
                            Cell cellListBox
                            Split stHoriz or stOriginBR or stJustGap, 8, 40, 0, 100
                              Cell cellColorSample
                              Cell cellColorButton
                          Cell cellLabelOptions
                        Cell cellCheckAutoBracket
                      Cell cellCheckAutoIndent
                    Cell cellCheckSmartTab
                  Cell cellCheckSecureSel
                Cell cellCheckOptimalFill
              Cell cellCheckConsoleCaret
            Cell cellCheckTabIndent
  SplitEnd




endg


cDefaultThemesDirectory text '%Fresh%\IDE\themes\'

cThemeSize = sizeof.TEditorSettings + sizeof.aeTheme + SyntaxColorCount*4





proc CustomWinProc, .hwnd, .wmsg, .wparam, .lparam
.rect RECT
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return


oncase FM_AFTERCREATE
locals
  .aep AEPOS
endl

; Set the splitgrid

        stdcall SetSplitGrid, [.hwnd], ColorsGrid

        stdcall AttachToCellDlgItem, [.hwnd], 300, ColorsGrid.cellLabelFont
        stdcall AttachToCellDlgItem, [.hwnd], 111, ColorsGrid.cellEditFont
        stdcall AttachToCellDlgItem, [.hwnd], 200, ColorsGrid.cellSampleEdit
        stdcall AttachToCellDlgItem, [.hwnd], 301, ColorsGrid.cellLabelSyntax
        stdcall AttachToCellDlgItem, [.hwnd], 106, ColorsGrid.cellListBox
        stdcall AttachToCellDlgItem, [.hwnd], 109, ColorsGrid.cellColorSample
        stdcall AttachToCellDlgItem, [.hwnd], 104, ColorsGrid.cellColorButton

        stdcall AttachToCellDlgItem, [.hwnd], 302, ColorsGrid.cellLabelOptions

        stdcall AttachToCellDlgItem, [.hwnd], 102, ColorsGrid.cellBtnLoad
        stdcall AttachToCellDlgItem, [.hwnd], 103, ColorsGrid.cellBtnSave

        stdcall AttachToCellDlgItem, [.hwnd], 416, ColorsGrid.cellCheckAutoBracket
        stdcall AttachToCellDlgItem, [.hwnd], 401, ColorsGrid.cellCheckAutoIndent
        stdcall AttachToCellDlgItem, [.hwnd], 402, ColorsGrid.cellCheckSmartTab
        stdcall AttachToCellDlgItem, [.hwnd], 408, ColorsGrid.cellCheckSecureSel
        stdcall AttachToCellDlgItem, [.hwnd], 404, ColorsGrid.cellCheckOptimalFill
        stdcall AttachToCellDlgItem, [.hwnd], 432, ColorsGrid.cellCheckConsoleCaret
        stdcall AttachToCellDlgItem, [.hwnd], 464, ColorsGrid.cellCheckTabIndent

; Fill listbox with color names.
        mov    esi, cSynListboxColors

        invoke  GetDlgItem, [.hwnd], 111
        invoke  GetDlgItem, eax, 1
        mov     ebx, eax
        invoke  GetWindowLongW, ebx, GWL_STYLE
        or      eax, BS_FLAT
        invoke  SetWindowLongW, ebx, GWL_STYLE, eax

.addloop:
        lodsd
        test    eax,eax
        jz      .OM_UPDATEDIALOG

        mov     ebx, [esi]
        add     esi, 4

        stdcall utf8ToWideChar, eax
        push    eax
        invoke  SendDlgItemMessageW, [.hwnd], 106, LB_ADDSTRING, 0, eax
        stdcall FreeMem ; from the stack

        cmp     eax, LB_ERR
        je      .addloop

        invoke  SendDlgItemMessageW, [.hwnd], 106, LB_SETITEMDATA, eax, ebx
        jmp     .addloop



oncase OM_SAVEOPTIONS

        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        stdcall ThemeDuplicate, eax

        xchg    [CurrentSettings], eax
        stdcall DestroySettings, eax

        stdcall EnumOpenFiles, ApplyCurrentTheme, NULL

        stdcall ApplySettingsToAsmEdit, [hLister], [CurrentSettings], fasm_syntax
        invoke  SendMessageW, [hLister], AEM_SETBOOKMARKICON, [hBookmarkIcon], [hBookmarkIcon+4]

        clc
        return




oncase OM_UPDATEDIALOG
.OM_UPDATEDIALOG:

; Set properties for preview window.
        invoke  GetDlgItem, [.hwnd], 200
        mov     esi, eax

        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     ebx, eax

        stdcall ApplySettingsToAsmEdit, esi, ebx, fasm_syntax

        stdcall SetControlTextUtf8, esi, cPreviewSource
        invoke  SendMessageW, esi, AEM_SETFOCUSLINE, 2, 0

        mov     [.aep.caretLine], 10
        mov     [.aep.caretPosition], 0
        mov     [.aep.selectionLine], 10
        mov     [.aep.selectionPosition], 255
        lea     eax, [.aep]
        invoke  SendMessageW, esi, AEM_SETPOS, eax, 0

; Set font name size and charset

; Name
        stdcall StrDup, [ebx+TEditorSettings.hFontName]
        mov     edi, eax
        stdcall StrCharCat, edi, ', '
; Size
        stdcall NumToStr, [ebx+TEditorSettings.FontSize], ntsDec
        stdcall StrCat, edi, eax
        stdcall StrDel, eax
        stdcall StrCharCat, edi, ', '

; Charset
        mov     ecx, [ebx+TEditorSettings.FontCharset]
        mov     esi, cFontCharsets
.setloop:
        lodsd
        test    eax, eax
        jz      .notfound

        mov     edx, eax
        lodsd
        cmp     eax, ecx
        jne     .setloop

        stdcall StrCat, edi, edx

.setfonttext:
        stdcall StrCharCat, edi, ', '
        stdcall NumToStr, [ebx+TEditorSettings.FontWeight], ntsDec or ntsUnsigned
        stdcall StrCat, edi, eax
        stdcall StrDel, eax

        cmp     [ebx+TEditorSettings.FontItalic], 0
        je      .italic_ok

        stdcall StrCharCat, edi, ', '
        stdcall StrCat, edi, 'Italic'

.italic_ok:
        stdcall SetDlgItemTextUtf8, [.hwnd], 111, edi
        stdcall StrDel, edi

; Set current selected color...
        invoke  SendDlgItemMessageW, [.hwnd], 106, LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        jne     .validselection

        invoke  GetDlgItem, [.hwnd], 104
        invoke  EnableWindow, eax, FALSE
        invoke  GetPropW, [.hwnd], [propColor]
        invoke  SendDlgItemMessageW, [.hwnd], 109, FM_SETCOLOR, eax, 0

; Now the checkboxes.

        invoke  GetWindow, [.hwnd], GW_CHILD
        mov     edi, [ebx+TEditorSettings.AsmEditStyle]

.stylesloop:
        mov     esi, eax

        invoke  GetWindowLongW, esi, GWL_ID
        cmp     eax, 400
        jl      .nextcheckbox
        cmp     eax, 500
        jge     .nextcheckbox

        sub     eax, 400
        test    edi, eax
        setnz   al
        movzx   eax, al

        invoke  SendMessageW, esi, BM_SETCHECK, eax, 0

.nextcheckbox:
        invoke  GetWindow, esi, GW_HWNDNEXT
        test    eax, eax
        jnz     .stylesloop

        clc
        return


.validselection:
        invoke  SendDlgItemMessageW, [.hwnd], 106, LB_GETITEMDATA, eax, 0

        mov     edi, [ebx+TEditorSettings.ptrTheme]
        mov     eax, [edi+eax]
        invoke  SendDlgItemMessageW, [.hwnd], 109, FM_SETCOLOR, eax, 0

        invoke  GetDlgItem, [.hwnd], 104
        invoke  EnableWindow, eax, TRUE

        clc
        return

.notfound:
        stdcall NumToStr, ecx, ntsSigned or ntsDec
        stdcall StrCat, edi, eax
        stdcall StrDel, eax
        jmp     .setfonttext



oncase WM_COMMAND
locals
  .cc CHOOSECOLOR
endl
        cmp     word [.wparam+2], LBN_SELCHANGE
        je      .colorlistbox

        cmp     word [.wparam], 102                  ; Load profile button ID
        je      .loadprofile

        cmp     word [.wparam], 103                  ; save profile button ID
        je      .saveprofile

        cmp     word [.wparam], 104                  ; ID of the "Color" button
        je      .changecolor

        cmp     word [.wparam], 400
        jb      .ondefault

        cmp     word [.wparam], 500
        ja      .ondefault

; Recreate AsmEdit styles

        invoke  GetWindow, [.hwnd], GW_CHILD
        xor     edi, edi

.loop:
        mov     esi, eax

        invoke  GetWindowLongW, esi, GWL_ID
        lea     ebx, [eax-400]
        cmp     ebx, 100
        ja      .next

        invoke  SendMessageW, esi, BM_GETCHECK, 0, 0
        cmp     eax, BST_CHECKED
        jne     .next

        or      edi, ebx

.next:
        invoke  GetWindow, esi, GW_HWNDNEXT
        test    eax, eax
        jnz     .loop

        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     esi, eax

        mov     [esi+TEditorSettings.AsmEditStyle], edi

        invoke  GetDlgItem, [.hwnd], 200
        stdcall ApplySettingsToAsmEdit, eax, esi, fasm_syntax

        xor     eax, eax
        clc
        return


;.....................................................................................

.saveprofile:
        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     edi, eax

        stdcall ConvertAliasString, cDefaultThemesDirectory
        mov     esi, eax

        stdcall SaveFileDialog, [.hwnd], cThemeSaveTitle, cThemesFilter, 0, esi
        test    eax, eax
        jz      .end_save

        push    eax
        stdcall SaveEditorSettings, eax, edi, FALSE, TRUE
        stdcall StrDel ; from the stack

.end_save:
        stdcall StrDel, esi
        clc
        return


;.....................................................................................


.loadprofile:

        invoke  GetParent, [.hwnd]
        mov     ebx, eax

        invoke  GetPropW, eax, [propTempSettings]
        mov     edi, eax

        stdcall ConvertAliasString, cDefaultThemesDirectory
        mov     esi, eax

        stdcall OpenFilesDialog, ebx, cThemeLoadTitle, FALSE, cThemesFilter, 0, esi, 0
        test    eax, eax
        jz      .end_load

        push    eax
        stdcall LoadEditorSettings, eax, TRUE
        stdcall StrDel ; from the stack
        jc      .errorload

        invoke  SetPropW, ebx, [propTempSettings], eax
        stdcall DestroySettings, edi

        invoke  SendMessageW, [.hwnd], OM_UPDATEDIALOG, 0, 0

.end_load:
        clc
        return

.errorload:
        test    eax, eax
        jnz     @f
        invoke  GetLastError
@@:
        stdcall ErrorMessage, eax
        clc
        return

;.....................................................................................




iglobal
  arrayCustomColors:
        times 16 dd $00ffffff
endg

.changecolor:
        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     edi, eax

        invoke  SendDlgItemMessageW, [.hwnd], 106, LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        je      .endcolorset

        invoke  SendDlgItemMessageW, [.hwnd], 106, LB_GETITEMDATA, eax, 0

        mov     edi, [edi+TEditorSettings.ptrTheme]
        lea     edi, [edi+eax]
        mov     eax, [edi]

        lea     esi, [.cc]
        mov     [esi+CHOOSECOLOR.lStructSize], sizeof.CHOOSECOLOR
        mov     [esi+CHOOSECOLOR.hwndOwner], 0
        mov     [esi+CHOOSECOLOR.rgbResult], eax
        mov     [esi+CHOOSECOLOR.lpCustColors], arrayCustomColors
        mov     [esi+CHOOSECOLOR.Flags], CC_RGBINIT or CC_ENABLEHOOK
        mov     [esi+CHOOSECOLOR.lpfnHook], CommonDialogHook

        invoke  ChooseColorW, esi
        test    eax, eax
        jz      .endcolorset

        mov     eax, [esi+CHOOSECOLOR.rgbResult]
        mov     [edi], eax
        invoke  SendDlgItemMessageW, [.hwnd], 109, FM_SETCOLOR, eax, 0
        jmp     .OM_UPDATEDIALOG


.endcolorset:
        clc
        return



.colorlistbox:
        movzx   eax, word [.wparam]
        cmp     eax, 106   ; id of the list box.
        jne     .ondefault

        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     esi, [eax+TEditorSettings.ptrTheme]

        invoke  SendMessageW, [.lparam], LB_GETCURSEL, 0, 0
        cmp     eax, LB_ERR
        je      .endcommand

        invoke  SendMessageW, [.lparam], LB_GETITEMDATA, eax, 0
        lea     esi, [esi+eax]

        invoke  SendDlgItemMessageW, [.hwnd], 109, FM_SETCOLOR, [esi], 0
        invoke  GetDlgItem, [.hwnd], 104
        invoke  EnableWindow, eax, TRUE

.endcommand:
        xor     eax, eax
        clc
        return


oncase BEM_BUTTONCLICK
locals
  .cf CHOOSEFONT
  .lf LOGFONTW
endl
        lea     esi, [.cf]
        mov     [.cf.lStructSize], sizeof.CHOOSEFONT

        mov     [.cf.hwndOwner], 0
        mov     [.cf.Flags], CF_FORCEFONTEXIST or CF_NOVECTORFONTS or CF_SCREENFONTS or CF_INITTOLOGFONTSTRUCT or CF_ENABLEHOOK ; or CF_FIXEDPITCHONLY

        lea     eax, [.lf]
        mov     [.cf.lpLogFont], eax

        mov     [.cf.lpfnHook], CommonDialogHook
        mov     [.cf.hDC], 0
        mov     [.cf.rgbColors], 0 ; it seems this is important only for Wine (if CF_EFFECTS is not set).

        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     esi, eax

        lea     edi, [.lf]
        mov     ecx, sizeof.LOGFONTW/4
        xor     eax, eax
        rep stosd

        mov     eax, [esi+TEditorSettings.FontSize]
        mov     ecx, [esi+TEditorSettings.FontCharset]
        mov     [.lf.lfHeight], eax
        mov     [.lf.lfCharSet], cl

        mov     eax, [esi+TEditorSettings.FontWeight]
        mov     ecx, [esi+TEditorSettings.FontItalic]
        mov     [.lf.lfWeight], eax
        mov     [.lf.lfItalic], cl

        stdcall utf8ToWideChar, [esi+TEditorSettings.hFontName]
        lea     edi, [.lf.lfFaceName]
        mov     esi, eax
        and     ecx, $1f

        rep movsw

        lea     esi, [.cf]
        invoke  ChooseFontW, esi
        test    eax, eax
        jz      .endfont

        invoke  GetParent, [.hwnd]
        invoke  GetPropW, eax, [propTempSettings]
        mov     edi, eax

        mov     eax, [.lf.lfHeight]
        movzx   ecx, [.lf.lfCharSet]
        mov     [edi+TEditorSettings.FontSize], eax
        mov     [edi+TEditorSettings.FontCharset], ecx

        mov     eax, [.lf.lfWeight]
        movzx   ecx, [.lf.lfItalic]
        mov     [edi+TEditorSettings.FontWeight], eax
        mov     [edi+TEditorSettings.FontItalic], ecx

        lea     eax, [.lf.lfFaceName]
        stdcall WideCharToUtf8, eax
        push    eax

        stdcall StrCopy, [edi+TEditorSettings.hFontName], eax
        stdcall StrDel ; from the stack

        invoke  SendMessageW, [.hwnd], OM_UPDATEDIALOG, 0, 0

.endfont:
        clc
        return

        enddispatch
endp


proc CommonDialogHook, .hwnd, .wmsg, .wparam, .lparam
.rect RECT
begin
        push    esi edi ebx

        dispatch [.wmsg]

        xor     eax, eax
        pop     ebx edi esi
        return

oncase WM_INITDIALOG

        lea     eax, [.rect]
        invoke  GetWindowRect, [.hwnd], eax

        invoke  GetSystemMetrics, SM_CXSCREEN
        sub     eax, [.rect.right]
        add     eax, [.rect.left]
        sar     eax,1
        mov     esi, eax

        invoke  GetSystemMetrics, SM_CYSCREEN
        sub     eax, [.rect.bottom]
        add     eax, [.rect.top]
        sar     eax,1
        mov     edi, eax

        invoke  SetWindowPos, [.hwnd], 0, esi, edi, 0, 0, SWP_NOSIZE or SWP_NOZORDER

        mov     eax, 1
        pop     ebx edi esi
        return

        enddispatch
endp





; EnumOpenFiles callback...
proc ApplyCurrentTheme, .ptrFile, .dummy
begin
        mov     esi, [.ptrFile]
        cmp     [esi+TOpenFile.hEditor], 0
        je      .exit

        stdcall GetAsmEdit, [esi+TOpenFile.hEditor]
        test    eax, eax
        jz      .exit

        mov     edi, eax
        mov     eax, [esi+TOpenFile.ptrType]

        stdcall ApplySettingsToAsmEdit, edi, [CurrentSettings], [eax+TFileType.lParam]

.exit:
        clc
        return
endp



;------------------------------------------------------------------
; THIS PROCEDURE CAN AND MUST BE USED FOR SETTING PROPERTIES FOR
; ALL ASMEDIT WINDOWS
;------------------------------------------------------------------
proc ApplySettingsToAsmEdit, .hAsmEdit, .ptrSettings, .ptrSyntaxProc
begin
        push    esi ebx

        mov     esi, [.ptrSettings]

; Apply style
        invoke  GetWindowLongW, [.hAsmEdit], GWL_STYLE
        and     eax, $ffffff00
        or      eax, [esi+TEditorSettings.AsmEditStyle]
        invoke  SetWindowLongW, [.hAsmEdit], GWL_STYLE, eax

; Apply font
        invoke  SendMessageW, [.hAsmEdit], WM_GETFONT, 0, 0
        mov     ebx, eax

        stdcall utf8ToWideChar, [esi+TEditorSettings.hFontName]
        push    eax
        xor     edx, edx
        invoke  CreateFontW, [esi+TEditorSettings.FontSize], edx, edx, edx,                     \
                             [esi+TEditorSettings.FontWeight],                                  \
                             [esi+TEditorSettings.FontItalic], edx, edx,                        \
                             [esi+TEditorSettings.FontCharset],                                 \
                             edx, edx, edx,                                                     \
                             edx, eax

        stdcall FreeMem ; from the stack

        invoke  SendMessageW, [.hAsmEdit], WM_SETFONT, eax, 0
        invoke  DeleteObject, ebx

; Apply colors and syntax highlighter
        invoke  SendMessageW, [.hAsmEdit], AEM_SETTHEME, 0, [esi+TEditorSettings.ptrTheme]
        invoke  SendMessageW, [.hAsmEdit], AEM_SETSYNTAXHIGHLIGHT, 0, [.ptrSyntaxProc]

        pop     ebx esi
        return
endp




;------------------------------------------
; Loads the file with editor settings and
; Returns pointer to its header.
;------------------------------------------
proc LoadEditorSettings, .hFileName, .absolute
begin
        push    ebx esi edi

        cmp     [.absolute], 0
        je      .relative

        stdcall FileOpenAccess, [.hFileName], faReadOnly
        mov     ebx, eax
        jmp     .proceed

.relative:
        stdcall StrDup, cDefaultThemesDirectory
        push    eax ; save for strdel

        stdcall StrCat, eax, [.hFileName]
        stdcall ConvertAliasString, eax
        push    eax

        stdcall FileOpenAccess, eax, faReadOnly
        mov     ebx, eax

        stdcall StrDel ; from the stack
        stdcall StrDel ; from the stack

.proceed:
        stdcall GetMem, cThemeSize
        mov     esi, eax

        lea     eax, [esi+sizeof.TEditorSettings]
        mov     [esi+TEditorSettings.ptrTheme], eax

        stdcall CfgGetStr, ebx, 'Theme', 'FontFace'
        jnc     .font_ok

        movx    eax, 'Courier New'      ; Windows default font.

        cmp     [procLinuxPath], 0
        je      .default_font

        movx    eax, 'Liberation Mono'

.default_font:
        stdcall StrDupMem, eax

.font_ok:
        mov     [esi+TEditorSettings.hFontName], eax

; determine the resolution...

        invoke  GetSystemMetrics, SM_CXSCREEN
        mov     ecx, -13
        cmp     eax, 1280         ; simple logic....
        jbe     .res_ok

        mov     ecx, -16        ; bigger font for the bigger screens.

.res_ok:
        stdcall CfgGetInt, ebx, 'Theme', 'FontSize', ecx
        mov     [esi+TEditorSettings.FontSize], eax

        stdcall CfgGetInt, ebx, 'Theme', 'FontCharset', DEFAULT_CHARSET
        mov     [esi+TEditorSettings.FontCharset], eax

        stdcall CfgGetInt, ebx, 'Theme', 'FontWeight', FW_NORMAL
        mov     [esi+TEditorSettings.FontWeight], eax

        stdcall CfgGetInt, ebx, 'Theme', 'FontItalic', FALSE
        mov     [esi+TEditorSettings.FontItalic], eax

        stdcall CfgGetInt, ebx, 'Theme', 'EditorStyle', AES_AUTOINDENT or AES_SMARTTABS or AES_CONSOLECARET
        mov     [esi+TEditorSettings.AsmEditStyle], eax

; colors
; the editor theme.
        push    esi

        mov     edi, [esi+TEditorSettings.ptrTheme]
        mov     esi, cSynListboxColors

.color_loop:
        lodsd   ; pointer to the key name.
        test    eax, eax
        jz      .end_colors

        mov     edx, eax
        lodsd   ; offset in the theme.
        mov     ecx, eax

        stdcall CfgGetInt, ebx, 'Theme.Colors', edx, 0
        jnc     .store_color

        mov     eax, [defaultAETHEME+ecx]

.store_color:
        mov     [edi+ecx], eax
        jmp     .color_loop

.end_colors:
        mov     [edi+aeTheme.margin_width], 20
        mov     [edi+aeTheme.margin_gap], 4
        mov     [edi+aeTheme.syntax_proc], fasm_syntax

        stdcall FileClose, ebx

        pop     eax     ; push esi

        pop     edi esi ebx
        clc
        return
endp


proc SaveEditorSettings, .hFileName, .ptrTheme, .fOverWrite, .absolute
begin
        push    ebx esi edi

        mov     esi, [.ptrTheme]

        cmp     [.absolute], 0
        je      .relative

        stdcall StrDup, [.hFileName]
        mov     ebx, eax
        jmp     .proceed

.relative:
        stdcall StrDup, cDefaultThemesDirectory
        push    eax ; save for strdel

        stdcall StrCat, eax, [.hFileName]
        stdcall ConvertAliasString, eax
        mov     ebx, eax        ; filename

        stdcall StrDel    ; from stack

.proceed:
        stdcall FileExists, ebx
        jc      .saveit

        cmp     [.fOverWrite], FALSE
        jne     .saveit

cThemeExists      text   'The theme "'
cThemeExistsEnd   text   '" already exists. Do you want to overwrite it?'

        stdcall StrDup, cThemeExists
        push    eax
        stdcall StrCat, eax, [.hFileName]
        stdcall StrCat, eax, cThemeExistsEnd
        stdcall StrPtr, eax

        stdcall AskQuestion, eax, [hMainForm], answerYesNo
        stdcall StrDel ; from stack
        cmp     eax, IDYES
        jne     .finish

.saveit:
        stdcall FileOpenAccess, ebx, faReadWrite or faOpenAlways
        stdcall StrDel, ebx
        mov     ebx, eax

        stdcall CfgSetStr, ebx, 'Theme', 'FontFace', [esi+TEditorSettings.hFontName]
        stdcall CfgSetInt, ebx, 'Theme', 'FontSize', [esi+TEditorSettings.FontSize]
        stdcall CfgSetInt, ebx, 'Theme', 'FontCharset', [esi+TEditorSettings.FontCharset]
        stdcall CfgSetInt, ebx, 'Theme', 'FontWeight', [esi+TEditorSettings.FontWeight]
        stdcall CfgSetInt, ebx, 'Theme', 'FontItalic', [esi+TEditorSettings.FontItalic]

        stdcall CfgSetInt, ebx, 'Theme', 'EditorStyle', [esi+TEditorSettings.AsmEditStyle]

; the editor theme.
        mov     edi, [esi+TEditorSettings.ptrTheme]
        mov     esi, cSynListboxColors

.color_loop:
        lodsd   ; pointer to the key name.
        test    eax, eax
        jz      .finish

        mov     edx, eax
        lodsd   ; offset in the theme.

        stdcall NumToStr, [edi+eax], ntsHex or ntsFixedWidth + 8
        stdcall StrCharCat, eax, 'h'
        push    eax

        stdcall CfgSetStr, ebx, 'Theme.Colors', edx, eax
        stdcall StrDel ; from the stack.
        jmp     .color_loop

.finish:
        stdcall FileClose, ebx

        xor     eax, eax
        pop     edi esi ebx
        return
endp



proc ThemeDuplicate, .ptrTheme
begin
        push    esi edi

        mov     esi, [.ptrTheme]
        sub     [esi+TEditorSettings.ptrTheme], esi

        stdcall GetMem, cThemeSize
        mov     edi, eax

        push    eax esi

        mov     ecx, cThemeSize/4
        rep movsd

        pop     esi edi

        stdcall StrDup, [esi+TEditorSettings.hFontName]
        mov     [edi+TEditorSettings.hFontName], eax

        add     [esi+TEditorSettings.ptrTheme], esi
        add     [edi+TEditorSettings.ptrTheme], edi

        mov     eax, edi
        pop     edi esi
        return
endp



proc DestroySettings, .ptrSettings
begin
        mov     eax, [.ptrSettings]
        test    eax, eax
        jz      .finish
        stdcall StrDel, [eax+TEditorSettings.hFontName]
        stdcall FreeMem, eax
.finish:
        return
endp

