;<ff
Window frmExternalOptions, 3, 0, 'TForm', 'External tools', $46000000, $10000, 0, 611, 212, 337, 256, frmExternalOptionsProc;
Window NONE, 0, 0, 'STATIC', 'Hint: In order to run Linux applications in Windows,  you have to install "andLinux".', $50000000, $0, 0, 8, 8, 320, 48, 0;
Window NONE, 0, 0, 'STATIC', 'andLinux &shared directory:', $50000000, $0, 0, 168, 56, 152, 20, 0;
Window NONE, 0, 0, 'STATIC', 'Win32 E&xternal debugger:', $50000200, $0, 0, 8, 176, 312, 20, 0;
Window NONE, 0, 0, 'TButtonEdit', '', $52810080, $0, 105, 8, 196, 312, 21, 0;
Window NONE, 0, 0, 'TButtonEdit', '', $52810080, $0, 106, 8, 76, 152, 21, 0;
Window NONE, 0, 0, 'TButtonEdit', '', $52810080, $0, 107, 168, 76, 152, 21, 0;
Window NONE, 0, 0, 'STATIC', 'Linux terminal:', $50000200, $0, 0, 168, 108, 152, 20, 0;
Window NONE, 0, 0, 'STATIC', 'and&Linux directory:', $50000000, $0, 0, 8, 56, 152, 20, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 109, 168, 128, 152, 21, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 108, 8, 128, 152, 21, 0;
Window NONE, 2, 0, 'STATIC', 'Linux debugger:', $50000200, $0, 0, 8, 108, 152, 20, 0;
;ff>

  cAndLinuxKey        text 'andLinux'
  cAndLinuxSharedKey  text 'LinuxSharedDir'
  cLinuxDbgKey        text 'LinuxDebugger'
  cLinuxTerminalKey   text 'LinuxTerminal'

iglobal
  cExecutablesFilter du 'Executables (*.exe)',0,'*.exe', 0
                     du 0

  cAndTitle    du 'Select andLinux directory:', 0
  cSharedTitle du 'Select andLinux shared directory:', 0
  cDbgTitle    du 'Select external debugger:', 0


endg


idDebuggerEdit      = 105
idAndLinuxDirEdit   = 106
idSharedDirEdit     = 107
idLinuxDebugEdit    = 108
idLinuxTerminalEdit = 109

proc frmExternalOptionsProc, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

        stc
        return

oncase WM_CLOSE
          clc
          return

oncase FM_AFTERCREATE
        invoke  SendDlgItemMessageW, [.hwnd], idDebuggerEdit,    BEM_SETBUTTONTEXT, 0, cTitleBtnEdit
        invoke  SendDlgItemMessageW, [.hwnd], idAndLinuxDirEdit, BEM_SETBUTTONTEXT, 0, cTitleBtnEdit
        invoke  SendDlgItemMessageW, [.hwnd], idSharedDirEdit,   BEM_SETBUTTONTEXT, 0, cTitleBtnEdit
        clc
        return

oncase OM_LOADOPTIONS

        stdcall GetParamFromINI, cAndLinuxKey
        jc      @f
        stdcall SetDlgItemTextUtf8, [.hwnd], idAndLinuxDirEdit, eax
        stdcall StrDel, eax
@@:

        stdcall GetParamFromINI, cAndLinuxSharedKey
        jc      @f
        stdcall SetDlgItemTextUtf8, [.hwnd], idSharedDirEdit, eax
        stdcall StrDel, eax
@@:

        stdcall GetParamFromINI, cLinuxDbgKey
        jc      @f
        stdcall SetDlgItemTextUtf8, [.hwnd], idLinuxDebugEdit, eax
        stdcall StrDel, eax
@@:

        stdcall GetParamFromINI, cDebugerKey
        jc      @f
        stdcall SetDlgItemTextUtf8, [.hwnd], idDebuggerEdit, eax
        stdcall StrDel, eax
@@:

        stdcall GetParamFromINI, cLinuxTerminalKey
        jc      @f
        stdcall SetDlgItemTextUtf8, [.hwnd], idLinuxTerminalEdit, eax
        stdcall StrDel, eax
@@:
        clc
        return


oncase OM_SAVEOPTIONS

        stdcall GetDlgItemTextUtf8, [.hwnd], idAndLinuxDirEdit
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cAndLinuxKey, eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], idSharedDirEdit
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cAndLinuxSharedKey, eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], idLinuxDebugEdit
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cLinuxDbgKey, eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], idDebuggerEdit
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cDebugerKey, eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], idLinuxTerminalEdit
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cLinuxTerminalKey, eax
        stdcall StrDel ; from the stack

        clc
        return


oncase BEM_BUTTONCLICK

        cmp     [.wparam], idAndLinuxDirEdit
        je      .linuxdir

        cmp     [.wparam], idSharedDirEdit
        je      .shareddir

        cmp     [.wparam], idDebuggerEdit
        je      .debugfile

        clc
        return

.linuxdir:
        invoke  GetDlgItem, [.hwnd], idAndLinuxDirEdit
        mov     esi, cAndTitle
        jmp     .commondirButtonEdit

.shareddir:
        invoke  GetDlgItem, [.hwnd], idSharedDirEdit
        mov     esi, cSharedTitle

.commondirButtonEdit:
        mov     ebx, eax

        stdcall GetControlTextUtf8, ebx
        push    eax

        stdcall SelectPathDialog, [hMainForm], esi, eax
        stdcall StrDel ; from the stack
        test    eax,eax
        jz      .nodir

        stdcall SetControlTextUtf8, ebx, eax
        stdcall StrDel, eax

.nodir:
        clc
        return

.debugfile:
        invoke  GetDlgItem, [.hwnd], idDebuggerEdit
        mov     ebx, eax

        stdcall GetControlTextUtf8, ebx
        push    eax

        stdcall OpenFilesDialog, [.hwnd], cDbgTitle, FALSE, cExecutablesFilter, ButtonEditFileSelect, eax, ebx
        stdcall StrDel ; from the stack
        clc
        return

        enddispatch
endp



