;<ff
Window frmIDEBehaviour, 3, 0, 'TForm', 'Other options', $46000000, $10000, 0, 849, 181, 362, 439, IDEBehaviourProc;
Window NONE, 0, 0, 'BUTTON', 'Auto hide message window', $50010002, $0, 100, 16, 16, 272, 21, 0;
Window NONE, 0, 0, 'STATIC', 'Hide interval:', $50000000, $0, 0, 16, 44, 76, 16, 0;
Window NONE, 0, 0, 'EDIT', '5000', $50012082, $200, 101, 92, 40, 49, 21, 0;
Window NONE, 0, 0, 'STATIC', 'ms', $50000000, $0, 0, 148, 44, 24, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Ignore WinApi suffix on search', $50000003, $0, 113, 16, 216, 320, 21, 0;
Window NONE, 0, 0, 'STATIC', 'Web browser:', $50000200, $0, 0, 16, 92, 200, 20, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 110, 16, 112, 320, 21, 0;
Window NONE, 0, 0, 'BUTTON', 'Search web as a last chance', $50000003, $0, 112, 16, 140, 320, 21, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 111, 32, 188, 304, 21, 0;
Window NONE, 0, 0, 'STATIC', 'Web search engine: (%q = query placeholder)', $50000200, $0, 0, 32, 168, 304, 20, 0;
Window NONE, 0, 5, 'BUTTON', ' Help and documentation  ', $54008307, $10020, 0, 0, 72, 354, 176, 0;
Window NONE, 0, 3, 'BUTTON', 'Message window', $54008307, $10020, 0, 0, 0, 354, 72, 0;
Window NONE, 0, 0, 'STATIC', 'Toolbar icon size:', $50000200, $0, 0, 16, 312, 200, 20, 0;
Window NONE, 0, 0, 'COMBOBOX', 'Combobox', $50000203, $0, 121, 16, 332, 120, 80, 0;
Window NONE, 0, 0, 'STATIC', 'Menu icon size:', $50000200, $0, 0, 16, 264, 200, 20, 0;
Window NONE, 0, 0, 'COMBOBOX', 'Combobox', $50000203, $0, 120, 16, 284, 120, 80, 0;
Window NONE, 2, 3, 'BUTTON', 'View options', $54008307, $10020, 0, 0, 248, 354, 128, 0;
;ff>
idAutoHideCheck = 100
idAutoHideTime  = 101

idWebBrowserEdit    = 110
idWebSearchEngine   = 111
idUseWebSearch      = 112
idRemoveApiSuffix   = 113

idMenuIconSize      = 120
idToolbarIconSize   = 121

cWebBrowserKey      text 'WebBrowser'
cUseWebSearchKey    text 'UseWebSearch'
cWebSearchKey       text 'WebSearchEngine'
cRemoveSuffix       text 'RemoveApiSuffix'


iglobal
  cSmallIcons  du "Small  16px", 0
  cMiddleIcons du "Middle 20px", 0
  cLargeIcons  du "Large  24px", 0
endg

;-----------------------------------------------------------------------
; Window procedure for the form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
proc IDEBehaviourProc, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return


oncase WM_COMMAND
        cmp     word [.wparam], idAutoHideCheck
        jne     .ondefault

        cmp     word [.wparam+2], BN_CLICKED
        jne     .ondefault

        invoke  SendDlgItemMessageW, [.hwnd], idAutoHideCheck, BM_GETCHECK, 0, 0
        mov     ebx, eax
        xor     ebx, 1
        invoke  SendDlgItemMessageW, [.hwnd], idAutoHideCheck, BM_SETCHECK, ebx, 0

        invoke  GetDlgItem, [.hwnd], idAutoHideTime
        invoke  EnableWindow, eax, ebx

        clc
        return

oncase FM_AFTERCREATE

        invoke  SendDlgItemMessageW, [.hwnd], idMenuIconSize, CB_ADDSTRING, 0, cSmallIcons
        invoke  SendDlgItemMessageW, [.hwnd], idMenuIconSize, CB_ADDSTRING, 0, cMiddleIcons
        invoke  SendDlgItemMessageW, [.hwnd], idMenuIconSize, CB_ADDSTRING, 0, cLargeIcons

        invoke  SendDlgItemMessageW, [.hwnd], idToolbarIconSize, CB_ADDSTRING, 0, cSmallIcons
        invoke  SendDlgItemMessageW, [.hwnd], idToolbarIconSize, CB_ADDSTRING, 0, cMiddleIcons
        invoke  SendDlgItemMessageW, [.hwnd], idToolbarIconSize, CB_ADDSTRING, 0, cLargeIcons

        clc
        return


oncase OM_LOADOPTIONS
        mov     eax, [flagAutoHide]
        invoke  SendDlgItemMessageW, [.hwnd], idAutoHideCheck, BM_SETCHECK, eax, 0

        invoke  SetDlgItemInt, [.hwnd], idAutoHideTime, [timeAutoHide], 0

        invoke  GetDlgItem, [.hwnd], idAutoHideTime
        invoke  EnableWindow, eax, [flagAutoHide]

        stdcall CfgGetStr, [hCfgFileName], cParamSection, cWebBrowserKey
        jc      @f

        stdcall SetDlgItemTextUtf8, [.hwnd], idWebBrowserEdit, eax
        stdcall StrDel, eax

@@:
        stdcall CfgGetStr, [hCfgFileName], cParamSection, cWebSearchKey, 0
        jc      @f

        stdcall SetDlgItemTextUtf8, [.hwnd], idWebSearchEngine, eax
        stdcall StrDel, eax

@@:

        stdcall CfgGetInt, [hCfgFileName], cParamSection, cUseWebSearchKey, 1
        and     eax, 1
        invoke  SendDlgItemMessageW, [.hwnd], idUseWebSearch, BM_SETCHECK, eax, 0

        stdcall CfgGetInt, [hCfgFileName], cParamSection, cRemoveSuffix, 1
        and     eax, 1
        invoke  SendDlgItemMessageW, [.hwnd], idRemoveApiSuffix, BM_SETCHECK, eax, 0

        mov     ebx, 2

        stdcall CfgGetInt, [hCfgFileName], cParamSection, cMenuIconKey, 0
        cmp     eax, ebx
        cmova   eax, ebx
        invoke  SendDlgItemMessageW, [.hwnd], idMenuIconSize, CB_SETCURSEL, eax, 0

        stdcall CfgGetInt, [hCfgFileName], cParamSection, cToolbarIconKey, 0
        cmp     eax, ebx
        cmova   eax, ebx
        invoke  SendDlgItemMessageW, [.hwnd], idToolbarIconSize, CB_SETCURSEL, eax, 0

        clc
        return


oncase OM_SAVEOPTIONS

        invoke  SendDlgItemMessageW, [.hwnd], idAutoHideCheck, BM_GETSTATE, 0, 0
        and     eax, 1
        mov     [flagAutoHide], eax
        stdcall CfgSetInt, [hCfgFileName], cParamSection, cAutoHideKey, eax

        invoke  GetDlgItemInt, [.hwnd], idAutoHideTime, 0, 0
        mov     [timeAutoHide], eax
        stdcall CfgSetInt, [hCfgFileName], cParamSection, cAutoHideTime, eax

        stdcall GetDlgItemTextUtf8, [.hwnd], idWebBrowserEdit
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cWebBrowserKey, eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], idWebSearchEngine
        push    eax
        stdcall CfgSetStr, [hCfgFileName], cParamSection, cWebSearchKey, eax
        stdcall StrDel ; from the stack

        invoke  SendDlgItemMessageW, [.hwnd], idUseWebSearch, BM_GETSTATE, 0, 0
        and     eax, 1
        stdcall CfgSetInt, [hCfgFileName], cParamSection, cUseWebSearchKey, eax

        invoke  SendDlgItemMessageW, [.hwnd], idRemoveApiSuffix, BM_GETSTATE, 0, 0
        and     eax, 1
        stdcall CfgSetInt, [hCfgFileName], cParamSection, cRemoveSuffix, eax

        mov     ebx, 2

        invoke  SendDlgItemMessageW, [.hwnd], idMenuIconSize, CB_GETCURSEL, 0, 0
        cmp     eax, ebx
        cmova   eax, ebx
        stdcall CfgSetInt, [hCfgFileName], cParamSection, cMenuIconKey, eax

        invoke  SendDlgItemMessageW, [.hwnd], idToolbarIconSize, CB_GETCURSEL, 0, 0
        cmp     eax, ebx
        cmova   eax, ebx
        stdcall CfgSetInt, [hCfgFileName], cParamSection, cToolbarIconKey, eax

        clc
        return

        enddispatch
endp


