;<ff
Window frmUserSyntax, 3, 0, 'TForm', 'Custom highlight', $46000000, $10000, 0, 370, 163, 320, 312, UserSyntaxProc;
Window NONE, 0, 0, 'STATIC', 'As &instruction:', $50000000, $0, 106, 24, 0, 160, 21, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 206, 8, 24, 297, 21, 0;
Window NONE, 0, 0, 'STATIC', 'As &assembler directive:', $50000000, $0, 107, 16, 128, 256, 21, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 207, 8, 152, 297, 21, 0;
Window NONE, 0, 0, 'STATIC', 'As &preprocessor directive:', $50000000, $0, 108, 16, 64, 256, 21, 0;
Window NONE, 0, 0, 'EDIT', '', $50810080, $0, 208, 8, 88, 297, 21, 0;
Window NONE, 0, 0, 'STATIC', 'As &register:', $50000000, $0, 105, 24, 184, 256, 21, 0;
Window NONE, 2, 0, 'EDIT', '', $50810080, $0, 205, 16, 216, 297, 21, 0;
;ff>

iglobal
  SplitStart SyntaxLayout
    Split stVert or stJustGap, 0, 20, 0, 100
      Cell cellInstrLbl
      Split stVert or stJustGap, 8, 21, 0, 100
        Cell cellInstrEdit
        Split stVert or stJustGap, 0, 20, 0, 100
          Cell cellAsmLbl
          Split stVert or stJustGap, 8, 21, 0, 100
            Cell cellAsmEdit
            Split stVert or stJustGap, 0, 20, 0, 100
              Cell cellPreprLbl
              Split stVert or stJustGap, 8, 21, 0, 100
                Cell cellPreprEdit
                Split stVert or stJustGap, 0, 20, 0, 100
                  Cell cellRegLbl
                  Split stVert or stJustGap, 8, 21, 0, 100
                    Cell cellRegEdit
                    Cell cellEmpty
  SplitEnd
endg



proc UserSyntaxProc, .hwnd, .wmsg, .wparam, .lparam
begin

        mov     ebx, [.wmsg]
        dispatch ebx

.ondefault:
        stc
        return

;--------------------------------
; Init columns of the listview
;--------------------------------
oncase FM_AFTERCREATE

        stdcall SetSplitGrid, [.hwnd], SyntaxLayout

        stdcall AttachToCellDlgItem, [.hwnd], 105, SyntaxLayout.cellRegLbl
        stdcall AttachToCellDlgItem, [.hwnd], 205, SyntaxLayout.cellRegEdit

        stdcall AttachToCellDlgItem, [.hwnd], 106, SyntaxLayout.cellInstrLbl
        stdcall AttachToCellDlgItem, [.hwnd], 206, SyntaxLayout.cellInstrEdit

        stdcall AttachToCellDlgItem, [.hwnd], 107, SyntaxLayout.cellAsmLbl
        stdcall AttachToCellDlgItem, [.hwnd], 207, SyntaxLayout.cellAsmEdit

        stdcall AttachToCellDlgItem, [.hwnd], 108, SyntaxLayout.cellPreprLbl
        stdcall AttachToCellDlgItem, [.hwnd], 208, SyntaxLayout.cellPreprEdit

        clc
        return


;----------------------------------------------------------
; Loads the path aliases ("environment variables") from
; the .ini file.
;-----------------------------------------------------------
oncase OM_LOADOPTIONS

        stdcall CfgGetStr, [hCfgFileName], 'UserSyntax', 'Registers'
        jc      .registers_ok

        stdcall SetDlgItemTextUtf8, [.hwnd], 205, eax
        stdcall StrDel, eax

.registers_ok:

        stdcall CfgGetStr, [hCfgFileName], 'UserSyntax', 'Instructions'
        jc      .instr_ok

        stdcall SetDlgItemTextUtf8, [.hwnd], 206, eax
        stdcall StrDel, eax

.instr_ok:

        stdcall CfgGetStr, [hCfgFileName], 'UserSyntax', 'AsmDirectives'
        jc      .asm_ok

        stdcall SetDlgItemTextUtf8, [.hwnd], 207, eax
        stdcall StrDel, eax

.asm_ok:
        stdcall CfgGetStr, [hCfgFileName], 'UserSyntax', 'PrepDirectives'
        jc      .prep_ok

        stdcall SetDlgItemTextUtf8, [.hwnd], 208, eax
        stdcall StrDel, eax

.prep_ok:

        clc
        return

;--------------------------------------------------------------------
; Saves the paths to the .ini file on exit of the dialog with MR_OK
;--------------------------------------------------------------------
oncase OM_SAVEOPTIONS

        stdcall GetDlgItemTextUtf8, [.hwnd], 205
        push    eax
        stdcall CfgSetStr, [hCfgFileName], 'UserSyntax', 'Registers', eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], 206
        push    eax
        stdcall CfgSetStr, [hCfgFileName], 'UserSyntax', 'Instructions', eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], 207
        push    eax
        stdcall CfgSetStr, [hCfgFileName], 'UserSyntax', 'AsmDirectives', eax
        stdcall StrDel ; from the stack

        stdcall GetDlgItemTextUtf8, [.hwnd], 208
        push    eax
        stdcall CfgSetStr, [hCfgFileName], 'UserSyntax', 'PrepDirectives', eax
        stdcall StrDel ; from the stack


        stdcall RebuildUserSyntax

        clc
        return


        enddispatch
endp



